package com.hzya.frame.seeyon.service;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.dynamic.datasource.annotation.DS;
import com.hzya.frame.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.seeyon.entity.SeeyonEntity;
import com.hzya.frame.seeyon.service.impl.CfsLogServiceImpl;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;

import java.util.List;
import java.util.Map;

/**
 * 致远OA接口类
 * @author 👻👻👻👻👻👻👻👻👻👻 gjh
 * @version 1.0
 * @content
 * @date 2023-08-22 9:29
 */
public interface ISeeYonInterFace {

    /***
     * 发起OA表单方法
     * @content:
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date  2023-08-22 9:31
     * @param requestData 请求json
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    JsonResultEntity thirdInterfaceSend(JSONObject requestData);

    /***
     * @Content:通过类型获取OA数据1
     * @Author 👻👻👻👻yqh👻👻👻👻
     * @Date2023年8月30日10:20:17seeYonPlugInInterfaceEntrance
     * @Param requestData
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/

    JsonResultEntity thirdInterfacegetOADataByType(JSONObject requestData);

    /***
     * @Content: 提供给OA的标准接口方法，包含参数 entity 为OA 的data信息， ,  eventType 为事件类型
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date  2020-12-24 10:36
     * @Param [entity, eventType]
     * eventType：
     * 发起前事件 onBeforeStart ,
     * 发起事件 onStart ,
     * 终止前事件 onBeforeStop ,
     * 终止事件 onStop,
     * 撤销前事件 onBeforeCancel,
     * 撤销事件 onCancel,
     * 结束事件 onProcessFinished,
     * 处理前事件 onBeforeFinishWorkitem,
     * 处理事件 onFinishWorkitem,
     * 回退前事件 onBeforeStepBack,
     * 回退事件 onStepBack,
     * 取回前事件 onBeforeTakeBack,
     * 取回事件 onTakeBack,
     * @return string
     **/
    JsonResultEntity thirdInterfaceSeeYonPlugInInterfaceEntrance(JSONObject requestData);
//    String seeYonPlugInInterfaceEntrance(OAWorkflowEventDataEntity entity,String eventType);

    /***
     * @Content:通过附件关系获取fileurl
     * @Author 👻👻👻👻yqh👻👻👻👻
     * @Date 2023年9月4日13:03:35
     * @Param requestData
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/

    /****
     * 客户服务器无法外网连接数据库，临时使用初始化方法
     * @content:
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date  2023-09-05 8:43
     * @param
     * @return com.hzya.frame.web.entity.JsonResultEntity
     **/
    JsonResultEntity thirdInterfaceInitBipSupplierToOa(JSONObject jsonObject) throws Exception;
    List<SeeyonEntity> getFileUrl(String sub_reference);
    /***
     *
     * @content:推送无流程表单同步钉钉
     * @author 👻👻👻👻👻👻👻👻 yuqh
     * @date  2023年9月2日12:56:18
     * @param
     * @return void
     **/
    JsonResultEntity sendConDocTodd(JSONObject requestJson);
    /***
     *
     * @content:流程表单传递钉钉
     * @author 👻👻👻👻👻👻👻👻 yuqh
     * @date  2023年9月5日09:38:38
     * @param
     * @return void
     **/
    JsonResultEntity sendProcessDocument(JSONObject requestJson);

   /**
    *
    * @content 杭泰OA付款单传递CFS
    * @Param
    * @Return
    * @Author hecan
    * @Date 2023/10/12 15:50
    * **/

    String sendpayMentToCFS(Map<String, Object> businessData);

    /**
     *
     * @content 杭泰OA报销单传递CFS
     * @Param
     * @Return
     * @Author hecan
     * @Date 2023/10/16 15:26
     * **/
    String sendBusinessExpenseToCFS(Map<String,Object> map,String formApp);

    /**
     *
     * @content 杭泰OA资金归集，资金拨付，同名账户划转，借款单传递CFS
     * @Param
     * @Return
     * @Author hecan
     * @Date 2023/12/20 10:04
     * **/
    String sendOtherFourReceipt(Map<String,Object> map,String formApp);


    /***
     * 致远OA业务流程集成补推方法,需要传递参数
     * @param  jsonObject formAppId 表单模版ID CAP_FORM_DEFINITION, formMainIds 集合  dataSourceCode 数据源编码
     * @return ht_oa_sqlserver
     * @throws Exception
     */
    JsonResultEntity thirdInterfaceSeeYonDefinitionRePush(JSONObject jsonObject) throws Exception;

    void setCfslogService(ICfsLogService cfsLogService);
}
