package com.hzya.frame.seeyon.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.collection.CollUtil;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.http.HttpUtil;
import cn.hutool.json.JSONUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.bip.v3.v2207.dps.service.IPayMentService;
import com.hzya.frame.dateutil.DateUtil;
import com.hzya.frame.dd.IDDInterfaceService;
import com.hzya.frame.seeyon.dao.ISeeYonDao;
import com.hzya.frame.seeyon.dao.ISeeYonInterFaceDao;
import com.hzya.frame.seeyon.entity.CfsLogEntity;
import com.hzya.frame.seeyon.entity.OAWorkflowEventDataEntity;
import com.hzya.frame.seeyon.entity.SeeYonInterFaceEntity;
import com.hzya.frame.seeyon.entity.SeeyonEntity;
import com.hzya.frame.seeyon.service.ICfsLogService;
import com.hzya.frame.seeyon.service.ISeeYonInterFace;
import com.hzya.frame.stringutil.StringUtil;
import com.hzya.frame.sys.service.IExcApiService;
import com.hzya.frame.u8c.Invmandoc.dao.IBdInvmandocDao;
import com.hzya.frame.u8c.Invmandoc.entity.BdInvmandocEntity;
import com.hzya.frame.u8c.Invmandoc.service.impl.BdInvmandocServiceImpl;

import com.hzya.frame.u8c.bdCumandoc.dao.IBdCumandocDao;
import com.hzya.frame.u8c.bdCumandoc.entity.BdCumandocEntity;
import com.hzya.frame.u8c.bdcorp.entity.BdCorpEntity;
import com.hzya.frame.u8c.bdcorp.service.IBdCorpService;
import com.hzya.frame.u8c.util.U8cHttpUtil;
import com.hzya.frame.uuid.UUIDLong;
import com.hzya.frame.web.action.ApplicationContextUtil;
import com.hzya.frame.web.entity.BaseResult;
import com.hzya.frame.web.entity.JsonResultEntity;
import com.hzya.frame.web.exception.BaseSystemException;
import org.apache.commons.lang3.ObjectUtils;
import org.apache.commons.lang3.StringUtils;
import org.checkerframework.checker.units.qual.K;
import org.junit.jupiter.api.Test;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import java.math.BigDecimal;
import java.util.*;

/**
 * @author 👻👻👻👻👻👻👻👻👻👻 gjh
 * @version 1.0
 * @content
 * @date 2023-08-22 9:30
 */
@Service(value = "seeYonInterFace")
public class SeeYonInterFaceImpl implements ISeeYonInterFace {
    private static final Logger logger = LoggerFactory.getLogger(SeeYonInterFaceImpl.class);
    /*** rest 用户名*/
    private static final String RESTUSERNAME = "hzyaRest";
    /*** rest 密码*/
    private static final String RESTPASSWORD = "a5ce21b8-91db-4cec-b3e3-3e44719655fd";
    // TODO 此处URL暂时写死，后续根据传递的应用ID获取
    private static final String sendUrl = "http://60.204.152.210/seeyon/";
    //速网esb地址
    private static final String baseUrl = "http://hzya.ufyct.com:9067/kangarooDataCenter/entranceController/externalCallInterface";
    @Resource
    private IExcApiService iExcApiService ;

    private ICfsLogService cfsLogService;
    @Override
    public void setCfslogService(ICfsLogService cfsLogService) {
        this.cfsLogService = cfsLogService;
    }

    /**
     * 定义所支持的事件静态代码块
     */
    private static final StringBuffer eventTypeBuffer = new StringBuffer();

    {
        eventTypeBuffer.append("发起前事件 onBeforeStart ,");
        eventTypeBuffer.append("发起事件 onStart ,");
        eventTypeBuffer.append("终止前事件 onBeforeStop ,");
        eventTypeBuffer.append("终止事件 onStop,");
        eventTypeBuffer.append("撤销前事件 onBeforeCancel,");
        eventTypeBuffer.append("撤销事件 onCancel,");
        eventTypeBuffer.append("结束事件 onProcessFinished,");
        eventTypeBuffer.append("处理前事件 onBeforeFinishWorkitem,");
        eventTypeBuffer.append("处理事件 onFinishWorkitem,");
        eventTypeBuffer.append("回退前事件 onBeforeStepBack,");
        eventTypeBuffer.append("回退事件 onStepBack,");
        eventTypeBuffer.append("取回前事件 onBeforeTakeBack,");
        eventTypeBuffer.append("取回事件 onTakeBack,");
    }

    //基础档案类型
    private final String ARCHIVESTYPE = "archives";
    //流程表单类型
    private final String FLOWTYPE = "flow";
    //创建基础档案
    private final String CREATEARCHIVES = "create";
    //更新基础档案
    private final String UPDATEARCHIVES = "update";
    //创建基础档案
    private final String CREATEARCHIVESURL = "rest/form/import/";
    //创建基础档案
    private final String UPDATEARCHIVESURL = "rest/form/update";
    @Resource
    private ISeeYonInterFaceDao seeYonInterFaceDao;

    @Resource
    private IPayMentService payMentService;

    @Autowired
    private ISeeYonDao seeYonDao;
    @Autowired
    private IBdInvmandocDao invmandocDao;
    @Autowired
    private IBdCorpService corpService;
    @Autowired
    private IBdCumandocDao bdCumandocDao;
    /**
     * 钉钉相关接口service
     */
    @Resource
    private IDDInterfaceService iddInterfaceService;
    //上一次同步时间
    private String LAST_SYNCHRONISED_TIME = "";
    /****
     * @Content:发起无流程表单接口实现
     * @Author 👻👻👻👻👻👻👻👻 gjh
     * @Date 2019/12/23 17:03
     * @Param [templateCode 模版编码, sendLoginName 发送人登录帐号 ,xmlData  ]
     * @return java.lang.Integer
     **/
    public static JsonResultEntity saveNoProcess(String templateCode , String interfaceUrl,String sendLoginName, String xmlData) {
        String token = getToken(RESTUSERNAME, RESTPASSWORD, sendLoginName);
        Map res = new HashMap();
        res.put("loginName", sendLoginName);
        res.put("dataXml", xmlData);
        res.put("token", token);
        String result = HttpRequest.post(sendUrl + interfaceUrl + templateCode).header("token", token).body(JSON.toJSONString(res)).execute().body();
        logger.info("无流程表单执行结果：" + result);
        return BaseResult.getFailureMessageEntity("执行成功", result);
    }

    public static JsonResultEntity upDateNoProcess(String interfaceUrl, String templateCode, String sendLoginName, String moduleId, String xmlData) {
        String token = getToken(RESTUSERNAME, RESTPASSWORD, sendLoginName);
        Map res = new HashMap();
        res.put("loginName", sendLoginName);
        res.put("dataXml", xmlData);
        res.put("token", token);
        res.put("moduleId", moduleId);
        res.put("templateCode", templateCode);
        logger.info("更新无流程表单参数:{}",JSON.toJSONString(res));
        String result = HttpRequest.put(sendUrl + interfaceUrl).header("token", token).body(JSON.toJSONString(res)).execute().body();
        logger.info("更新无流程表单执行结果：" + result);
        return BaseResult.getFailureMessageEntity("执行成功", result);
    }

    //    {
//        "moduleId":"5701605966502512923",
//            "templateCode":"formmain_0360",
//            "loginName":"seeyon",
//            "dataXml":"<forms  version=\"2.1\"><formExport><summary  id=\"7382733425750590212\" name=\"formmain_0360\"/><definitions><column  id=\"field0001\" type=\"0\" name=\"供应商编码\" isNullable=\"false\" length=\"100\"/><column  id=\"field0002\" type=\"0\" name=\"供应商名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0007\" type=\"0\" name=\"税号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0008\" type=\"0\" name=\"地址\" isNullable=\"false\" length=\"100\"/><column  id=\"field0009\" type=\"0\" name=\"电话\" isNullable=\"false\" length=\"100\"/><column  id=\"field0011\" type=\"0\" name=\"联系人\" isNullable=\"false\" length=\"100\"/></definitions><values><column  name=\"供应商编码\"><value><![CDATA[ 12345 ]]></value></column><column  name=\"供应商名称\"><value><![CDATA[ 测试客户银行1111 ]]></value></column><column  name=\"税号\"><value><![CDATA[ 982698741E96 ]]></value></column><column  name=\"地址\"><value><![CDATA[ 杭州 ]]></value></column><column  name=\"电话\"><value><![CDATA[ null ]]></value></column><column  name=\"联系人\"><value><![CDATA[ null ]]></value></column></values><subForms><subForm><definitions><column  id=\"field0003\" type=\"4\" name=\"序号\" isNullable=\"false\" length=\"20\"/><column  id=\"field0005\" type=\"0\" name=\"开户行名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0006\" type=\"0\" name=\"银行账号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0004\" type=\"0\" name=\"是否默认\" isNullable=\"false\" length=\"100\"/></definitions><values><row><column  name=\"序号\"><value><![CDATA[1]]></value><title><![CDATA[1438373948291346275]]></title></column><column  name=\"开户行名称\"><value><![CDATA[1234]]></value><title><![CDATA[9218745623489128746]]></title></column><column  name=\"银行账号\"><value><![CDATA[111111111]]></value><title><![CDATA[6897123456789123456]]></title></column><column  name=\"是否默认\"><value><![CDATA[是]]></value><title><![CDATA[5729461284567891234]]></title></column></row></values></subForm></subForms></formExport></forms>"
//    }
    private static String getToken(String userName, String password, String loginName) {
        JSONObject jsonObject = new JSONObject();
        /** 获取token*/

        jsonObject.put("userName", userName);
        jsonObject.put("password", password);
        jsonObject.put("loginName", loginName);
        logger.info("请求获取token开始---------------------------------------------");
        logger.info("请求参数" + jsonObject.toJSONString());
        String result = HttpUtil.post(sendUrl + "rest/token", jsonObject.toJSONString());
        logger.info("获取token结果---------------------------------------------" + result);
        logger.info("获取token结果---------------------------------------------" + result);
        jsonObject = JSONObject.parseObject(result);
        if ("".equals(result) || result == null) {
            logger.info("获取token失败！");
            throw new RuntimeException("获取token失败！");
        } else {
            String token = jsonObject.get("id").toString();
            return token;
        }
    }

    /***
     * 发起OA表单方法
     * @content:
     * @author 👻👻👻👻👻👻👻👻 gjh
     * @date 2023-08-22 9:32
     * @param
     * @return com.hzya.frame.web.entity.BaseResult
     **/
    @Override
    public JsonResultEntity thirdInterfaceSend(JSONObject requestData) {
        JSONObject jsonStr = requestData.getJSONObject("jsonStr");
        if (ObjectUtils.isEmpty(jsonStr)) {
            throw new BaseSystemException("jsonStr为空！请传递参数");
        }
        //类型 flow archives
        String type = jsonStr.getString("type");
        if (StringUtils.isEmpty(type)) {
            throw new BaseSystemException("请传递类型！type 流程表单：flow 基础档案：archives");
        }
        //模版编号
        String templateCode = jsonStr.getString("templateCode");
        if (StringUtils.isEmpty(templateCode)) {
            throw new BaseSystemException("请传入模版编号！templateCode不允许为空");
        }
        JSONObject data = jsonStr.getJSONObject("data");
        String attributeArrayStr = jsonStr.getString("attribute");
        if (StringUtils.isEmpty(attributeArrayStr)) {
            throw new BaseSystemException("attribute不允许为空");
        }
        List<JSONObject> attributeArray = JSON.parseArray(attributeArrayStr, JSONObject.class);
        JsonResultEntity result = null;
        if (ARCHIVESTYPE.equalsIgnoreCase(type)) {
            switch (templateCode){
                //供应商
                case "formmain_0360":
                    for (JSONObject jsonObject : attributeArray) {
                        //根据ID获取OA档案是否有数据，如果有数据则调用更新接口
                        String tripartiteId = jsonObject.getString("tripartiteId");
                        //如果三方系统ID为空则直接发起OA的基础档案
                        if (StringUtils.isEmpty(tripartiteId)) {
                            String dataXml = createTempData(jsonObject, CREATEARCHIVES);
                            String loginName = "seeyon";
                            Map res = new HashMap();
                            res.put("loginName", loginName);
                            res.put("dataXml", dataXml);
                            result = saveNoProcess( "formmain_0360", "rest/form/import/", loginName, dataXml);
                            logger.info("发起无流程表单结果：" + result);
                        } else {
                            SeeYonInterFaceEntity seeYonInterFaceEntity = new SeeYonInterFaceEntity();
                            seeYonInterFaceEntity.setTripartiteId(tripartiteId);
                            seeYonInterFaceEntity.setTabName(templateCode);
                            seeYonInterFaceEntity.setOaField("field0012");
                            List<SeeYonInterFaceEntity> archives = seeYonInterFaceDao.queryArchives(seeYonInterFaceEntity);
                            //如果根据三方系统ID有查询到数据，则走更新
                            if (null != archives && archives.size() > 0) {
                                String dataXml = createTempData(jsonObject, UPDATEARCHIVES);
                                String loginName = "seeyon";
                                String moduleId = archives.get(0).getId();
                                Map res = new HashMap();
                                res.put("loginName", loginName);
                                res.put("dataXml", dataXml);
                                result = upDateNoProcess(UPDATEARCHIVESURL, "formmain_0360", loginName, moduleId, dataXml);
                                logger.info("更新无流程表单结果：" + result);
                            } else {
                                String dataXml = createTempData(jsonObject, CREATEARCHIVES);
                                String loginName = "seeyon";
                                Map res = new HashMap();
                                res.put("loginName", loginName);
                                res.put("dataXml", dataXml);
                                result = saveNoProcess( "formmain_0360","rest/form/import/", loginName, dataXml);
                                logger.info("发起无流程表单结果：" + result);
                            }
                        }
                    }
                    break;
                //组织
                case "formmain_0380":
                    for (JSONObject jsonObject : attributeArray) {
                        //根据ID获取OA档案是否有数据，如果有数据则调用更新接口
                        String tripartiteId = jsonObject.getString("tripartiteId");
                        //如果三方系统ID为空则直接发起OA的基础档案
                        if (StringUtils.isEmpty(tripartiteId)) {
                            String dataXml = createOrgTempData(jsonObject, CREATEARCHIVES);
                            String loginName = "seeyon";
                            Map res = new HashMap();
                            res.put("loginName", loginName);
                            res.put("dataXml", dataXml);
                            result = saveNoProcess( "formmain_0380", "rest/form/import/", loginName, dataXml);
                            logger.info("BIP组织发起无流程表单结果：" + result);
                        } else {
                            SeeYonInterFaceEntity seeYonInterFaceEntity = new SeeYonInterFaceEntity();
                            seeYonInterFaceEntity.setTripartiteId(tripartiteId);
                            seeYonInterFaceEntity.setTabName(templateCode);
                            seeYonInterFaceEntity.setOaField("field0008");
                            List<SeeYonInterFaceEntity> archives = seeYonInterFaceDao.queryArchives(seeYonInterFaceEntity);
                            //如果根据三方系统ID有查询到数据，则走更新
                            if (null != archives && archives.size() > 0) {
                                String dataXml = createOrgTempData(jsonObject, UPDATEARCHIVES);
                                String loginName = "seeyon";
                                String moduleId = archives.get(0).getId();
                                Map res = new HashMap();
                                res.put("loginName", loginName);
                                res.put("dataXml", dataXml);
                                result = upDateNoProcess(UPDATEARCHIVESURL, "formmain_0380", loginName, moduleId, dataXml);
                                logger.info("BIP组织更新无流程表单结果：" + result);
                            } else {
                                String dataXml = createOrgTempData(jsonObject, CREATEARCHIVES);
                                String loginName = "seeyon";
                                Map res = new HashMap();
                                res.put("loginName", loginName);
                                res.put("dataXml", dataXml);
                                result = saveNoProcess( "formmain_0380","rest/form/import/", loginName, dataXml);
                                logger.info("BIP组织发起无流程表单结果：" + result);
                            }
                        }
                    }
                    break;
                //保存交行cfs日志
                case "formmain_0527":
                    for (JSONObject jsonObject : attributeArray){
                        String dataXml = createCfsTempData(jsonObject, CREATEARCHIVES);
                        String loginName = "seeyon";
                        Map res = new HashMap();
                        res.put("loginName", loginName);
                        res.put("dataXml", dataXml);
                        result = saveNoProcess( "formmain_0527","rest/form/import/", loginName, dataXml);
                        logger.info("BIP组织发起无流程表单结果：" + result);
                    }
                    break;
            }
        }
        if (FLOWTYPE.equalsIgnoreCase(type)) {
        }
        return result;
    }


    @Override
    public JsonResultEntity thirdInterfaceSeeYonPlugInInterfaceEntrance(JSONObject requestData){
        String jsonStr = requestData.getString("jsonStr");
        JSONObject jsonObject = requestData.getJSONObject("jsonStr");
        OAWorkflowEventDataEntity entity = JSON.parseObject(jsonStr,OAWorkflowEventDataEntity.class);
        logger.info("监听OA事件入参："+jsonObject.toJSONString());
        JSONObject formBeanData = jsonObject.getJSONObject("businessDataStr");
        String eventType = jsonObject.getString("eventType") ;
        /** 流程ID*/
        String summaryId = entity.getSummaryId();
        /** 节点ID*/
        String affairId = entity.getAffairId();
        String currentActivityId = entity.getCurrentActivityId();
        /****/
        String formViewOperation = entity.getFormViewOperation();
        Object summaryObj = entity.getSummaryObj();
        String deeCfgId = entity.getDeeCfgId();
        String currentNodeLast = entity.getCurrentNodeLast();
        Map<String, Object> businessData = JSON.parseObject(entity.getBusinessDataStr(), Map.class);
        Map<String, Object> extData = entity.getExtData();
        /** 表单表的FORM ID,用此字段标记是哪个流程*/
        String formApp = entity.getFormApp();




        String result = null;
        /** 根据事件类型处理相关事件*/
        switch (eventType) {
            /** 发起前事件*/
            case "onBeforeStart":
                break;
            /** 发起事件*/
            case "onStart":
                break;
            /** 终止前事件*/
            case "onBeforeStop":
                break;
            /** 终止事件*/
            case "onStop":
                break;
            /** 撤销前事件*/
            case "onBeforeCancel":
                break;
            /** 撤销事件*/
            case "onCancel":
                break;
            /** 结束事件*/
            case "onProcessFinished":
                /** 根据form处理相关业务表单的数据*/
                switch (formApp) {
                    // todo 杭泰
                    case "8829094357593836499":
                        //发起钉钉审批单据
                        result = ddApproveFinish(businessData);
                        break;
                    //杭泰正式环境审批单
                    case "9158638526010969190"://出差申请单
                        //发起钉钉审批单据
                        result = ddApproveFinish(formBeanData);//考勤
                        logger.info("考勤返回数据"+result);
                        result = boundData(businessData,formApp);//流程结束归档钉钉
                        logger.info("归档钉钉返回数据"+result);
                        break;
                    case "-1294748925451877119"://本地测试环境
                        result = ddApproveFinish(businessData);
                        break;
                    case "-2680578642756943477"://对公付款单
                        result = boundData(businessData,formApp);
                        logger.info("对公付款单返回数据：{}",result);
                        result = sendpayMentToCFS(businessData);
                        logger.info("对公付款单传递CFS返回数据：{}",result);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("对公付款单","formmain_0327",entity,result));
                        break;
                    case "-8072984621869285290"://开票申请
                        result = boundData(businessData,formApp);
                        break;
                    case "-321958445006631163"://差旅费报销单
                        result = boundData(businessData,formApp);
                        logger.info("差旅费报销单返回数据:{}",result);
                        result=sendBusinessExpenseToCFS(businessData, formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("差旅报销单","formmain_0307",entity,result));
                        break;
                    case "-4485599744122928342"://招待费报销单
                        result = boundData(businessData,formApp);
                        logger.info("招待费报销单返回数据:{}",result);
                        result=sendBusinessExpenseToCFS(businessData, formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("招待费报销单","formmain_0294",entity,result));
                        break;
                    case "4728403652378707515"://日常费用报销单
                        result = boundData(businessData,formApp);
                        logger.info("日常费用报销单返回数据:{}",result);
                        result=sendBusinessExpenseToCFS(businessData, formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("日常费用报销单","formmain_0314",entity,result));
                        break;
                    case "910366613209564645"://资金归集
                        result=sendOtherFourReceipt(businessData,formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("资金归集","formmain_0362",entity,result));
                        break;
                    case "-102527561419044497"://资金拨付
                        result=sendOtherFourReceipt(businessData,formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("资金拨付","formmain_0464",entity,result));
                        break;
                    case "-1193625514072190978"://同名账户划转
                        result=sendOtherFourReceipt(businessData,formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("同名账户划转","formmain_0467",entity,result));
                        break;
                    case "4645133897573090505"://借款单(借还款)
                        result=sendOtherFourReceipt(businessData,formApp);
                        //保存日志
                        cfsLogService.importCfsLog(new CfsLogEntity("借款单(借还款)","formmain_0293",entity,result));
                        break;
                    //todo 速网
                    case "9052446288734537446"://速网存货档案
                        result=boundDataSW(businessData,formApp);
                        break;
                    case "-7835496631017455043"://速网客商档案
                        result=boundDataSW(businessData,formApp);
                        break;
                    case "-4417416588206651590"://速网销售订单
                        result=boundDataSW(businessData,formApp);
                        break;
                    case "7910359204154002618"://速网采购订单
                        result = boundDataSW(businessData,formApp);
                        break;
                    case "852319851043310560"://采购付款单
                        result = boundDataSW(businessData,formApp);
                        break;
                    case "-4882495686115769173"://出入库申请单
                        result = boundDataSW(businessData,formApp);
                        break;
                    default:
                        return   BaseResult.getFailureMessageEntity("未匹配到表单！当前formID：" + formApp, "", "");
                }
                break;
            /** 处理前事件*/
            case "onBeforeFinishWorkitem":
                /** 根据form处理相关业务表单的数据*/
                switch (formApp) {
                    case "8829094357593836499":
                        //发起钉钉单据
                        ddApproveFinish(businessData);
                        break;
                    default:

                        return   BaseResult.getFailureMessageEntity("未匹配到表单！当前formID：" + formApp,  "");
                }
                break;
            /** 处理事件*/
            case "onFinishWorkitem":
                break;
            /** 回退前事件*/
            case "onBeforeStepBack":
                break;
            /** 回退事件*/
            case "onStepBack":
                break;
            /** 取回前事件*/
            case "onBeforeTakeBack":
                break;
            /** 取回事件*/
            case "onTakeBack":
                break;
            default:
//                throw new RuntimeException("传入了非法事件类型！请参照：" + eventTypeBuffer.toString());
                return   BaseResult.getFailureMessageEntity("传入了非法事件类型！请参照：" + eventTypeBuffer.toString(), "", "");
        }
        return BaseResult.getSuccessMessageEntity("传递成功",  result);
    }


    private String ddApproveFinish(JSONObject formBeanData) {
        JSONObject forMainData = formBeanData.getJSONObject("formmain_0302");
        JSONObject finishData = new JSONObject();
        String to_time = forMainData.getString("field0038");
        String from_time = forMainData.getString("field0036");
        finishData.put("userid", forMainData.get("field0083"));
        finishData.put("biz_type", "2");
        finishData.put("from_time", from_time);
        finishData.put("to_time", to_time);
        finishData.put("duration_unit", "day");
        finishData.put("tag_name", "出差");
        finishData.put("calculate_model", "1");
        finishData.put("approve_id", "approve_id");
        finishData.put("jump_url", "jump_url");
        JSONObject ddData = new JSONObject();
        ddData.put("code", "0002");
        ddData.put("data", finishData.toJSONString());
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("jsonStr", ddData.toJSONString());
        return iddInterfaceService.senddd(jsonObject);
    }

    /**
     * 组装传递钉钉参数，通过表单ID区分杭泰
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundData(Map<String, Object> businessData, String formApp) {
        String result = "";
        JSONObject finishData = new JSONObject();
        try {
            switch (formApp){
                case "-2680578642756943477"://对公付款单
                    finishData = boundDataPay(businessData,formApp);
                    break;
                case "-8072984621869285290"://开票申请
                    finishData = boundDataInv(businessData,formApp);
                    break;
                case "9158638526010969190"://出差申请单
                    finishData = boundDataBusinessTravel(businessData,formApp);
                    break;
                case "-321958445006631163"://差旅费报销单
                    finishData = boundDataTravelExpense(businessData,formApp);
                    break;
                case "-4485599744122928342"://招待费报销单
                    finishData = boundDataEntertain(businessData,formApp);
                    break;
                case "4728403652378707515"://日常费用报销单
                    finishData = boundDatacurrentExpense(businessData,formApp);
                    break;
                default:
                    break;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return e.getMessage();
        }
        JSONObject jsonObject = new JSONObject();
        JSONObject data = new JSONObject();
        data.put("data",finishData);
        data.put("code","0003");
        jsonObject.put("jsonStr",data);

        return iddInterfaceService.senddd(jsonObject);
    }
    /**
     * 组装传递钉钉参数，通过表单ID区分杭泰
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundDataSW(Map<String, Object> businessData, String formApp) {
        String result = "";
        try {
            switch (formApp){
                case "-7835496631017455043"://客商档案-速网
                    result = boundSWcustDoc(businessData,formApp);
                    break;
                case "9052446288734537446"://存货档案-速网
                    result = boundSWinvDoc(businessData,formApp);
                    break;
                case "-4417416588206651590"://销售订单-速网
                    result = boundSWSaleOrder(businessData,formApp);
                    break;
                case "7910359204154002618"://采购订单-速网
                    result = boundSWPUOrder(businessData,formApp);
                    break;
                case "852319851043310560"://采购付款单-速网
                    result = boundSWPUPy(businessData,formApp);
                    break;
                case "-4882495686115769173"://出入库申请单
                    result = boundSWWarehouse(businessData,formApp);
                    break;

                default:
                    break;
            }
        } catch (Exception e) {
            e.printStackTrace();
            return e.getMessage();
        }
        return result;
    }
    /***
     * @Content:出入库申请单
     * @Author 👻👻👻👻yqh👻👻👻👻
     * @Date  2023年11月22日13:51:47
     * @Param
     * @return
     **/
    private String boundSWWarehouse(Map<String, Object> businessData, String formApp) {
        JSONObject result = new JSONObject();
        Object mainObj = businessData.get("formmain_0218");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        String field0061 = businessDatamain.getString("field0061");
        //通过类型判断推送不同的单据
        switch (field0061){
            case "8474321469568075747"://盘点如果其他出库明细不为空 生成U8C其他出库单，如果其他入库明细不为空生成U8C其他入库单
                result = warehouseCheck(businessData);
                break;
            case "5763280962704524077"://（报废）需要先生成U8C从A仓库到B仓库的调拨单（仓库通过DEE选择） 再生成B仓库的其他出库单
                result = scrap(businessData);
                break;
            case "-4669957817622313882"://（调拨），就生成U8C A公司调拨到B公司的调拨单仓库在表体，自己选择
                result = allotOrder(businessData);
                break;
            default:
                logger.info("未匹配单该单据类型，不予推送该出入库申请单");
                break;
        }
        return result.toString();
    }

    /**
     * （报废）需要先生成U8C从A仓库到B仓库的调拨单（仓库通过DEE选择） 再生成B仓库的其他出库单
     * @param businessData
     * @return
     */
    private JSONObject scrap(Map<String, Object> businessData) {
        JSONObject result = new JSONObject();
        Object mainObj = businessData.get("formmain_0218");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        Object formson_0236obj = businessData.get("formson_0236");

        //调拨订单
        JSONArray formson_0236Arr = JSON.parseArray(JSON.toJSONString(formson_0236obj));
        for(Object obj : formson_0236Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            String invId = body.getString("field0110");
            if(StrUtil.isEmpty(invId)){
                logger.info("未加载到调拨订单数据");
            }
            //第一 组装数据推送调拨订单
            result = bindAllotOrder(businessDatamain,body);
            //第一 组装数据推送其他出库单，因接口公用存在，在此拼接公用参数
            businessDatamain.put("field0124",body.getString("field0148"));//公司
            body.put("field0101",body.getString("field0107"));//仓库
            body.put("field0154",body.getString("field0151"));//库存组织
            body.put("field0108",body.getString("field0110"));//存货
            body.put("field0126",body.getString("field0077"));//应出数量
            body.put("field0058",body.getString("field0077"));//实出数量
            body.put("field0172",body.getString("field0173"));//是否批次

            result = otherOutWarehouse(businessDatamain,body);
        }
        return result;
    }

    /***
     * @Content:调拨
     * @Author 👻👻👻👻yqh👻👻👻👻
     * @Date  2023年11月23日09:06:34
     * @Param
     * @return
     **/
    private JSONObject allotOrder(Map<String, Object> businessData) {
        JSONObject result = new JSONObject();
        Object mainObj = businessData.get("formmain_0218");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        Object formson_0236obj = businessData.get("formson_0236");

        //调拨订单
        JSONArray formson_0236Arr = JSON.parseArray(JSON.toJSONString(formson_0236obj));
        for(Object obj : formson_0236Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            String invId = body.getString("field0110");
            if(StrUtil.isEmpty(invId)){
                logger.info("未加载到调拨订单数据");
            }
            //组装数据推送调拨订单
            result = bindAllotOrder(businessDatamain,body);
        }
        return result;
    }

    /**
     * 组装数据推送调拨订单
     * @param businessDatamain
     * @param body
     * @return
     */
    private JSONObject bindAllotOrder(JSONObject businessDatamain, JSONObject body) {
        JSONObject result = new JSONObject();
        JSONObject sendData = new JSONObject();
        JSONArray billvo = new JSONArray();
        sendData.put("billvo",billvo);
        JSONObject main = new JSONObject();
        billvo.add(main);
        JSONObject parentvo = new JSONObject();
        JSONArray childrenvo = new JSONArray();
        main.put("parentvo",parentvo);
        parentvo.put("cbiztypeid",businessDatamain.getString("field0133"));//业务流程
        parentvo.put("coperatorid",businessDatamain.getString("field0136"));//制单人
        parentvo.put("dbilldate",businessDatamain.getString("field0003"));//单据日期

        parentvo.put("cincorpid",body.getString("field0148"));//调入公司
        parentvo.put("cincbid",body.getString("field0151"));//调入组织
        parentvo.put("cinwhid",body.getString("field0107"));//调入仓库
        parentvo.put("coutcorpid",body.getString("field0142"));//调出公司
        parentvo.put("coutcbid",body.getString("field0145"));//调出组织
        parentvo.put("coutwhid",body.getString("field0105"));//调出仓库
        parentvo.put("coutcurrtype",body.getString("field0167"));//币种
//        parentvo.put("vbdef1",businessDatamain.getString("field0162"));//店铺
//        parentvo.put("vbdef2",businessDatamain.getString("field0165"));//平台
//        parentvo.put("vbdef3",businessDatamain.getString("field0096"));//品牌
//        parentvo.put("vbdef4",businessDatamain.getString("field0097"));//业务中心
//        parentvo.put("vbdef5",businessDatamain.getString("field0098"));//业务模式
//        parentvo.put("pk_defdoc1",businessDatamain.getString("field0160"));//店铺
//        parentvo.put("pk_defdoc2",businessDatamain.getString("field0163"));//平台
//        parentvo.put("pk_defdoc3",businessDatamain.getString("field0118"));//品牌
//        parentvo.put("pk_defdoc4",businessDatamain.getString("field0120"));//业务中心
//        parentvo.put("pk_defdoc5",businessDatamain.getString("field0122"));//业务模式

        parentvo.put("vdef10",businessDatamain.getString("field0097"));//业务中心
        parentvo.put("vdef11",businessDatamain.getString("field0098"));//业务模式
        parentvo.put("vdef12",businessDatamain.getString("field0162"));//店铺
        parentvo.put("vdef13",businessDatamain.getString("field0096"));//品牌
        parentvo.put("vdef14",businessDatamain.getString("field0165"));//平台

        parentvo.put("pk_defdoc10",businessDatamain.getString("field0120"));//业务中心
        parentvo.put("pk_defdoc11",businessDatamain.getString("field0122"));//业务模式
        parentvo.put("pk_defdoc12",businessDatamain.getString("field0160"));//店铺
        parentvo.put("pk_defdoc13",businessDatamain.getString("field0118"));//品牌
        parentvo.put("pk_defdoc14",businessDatamain.getString("field0163"));//平台
        main.put("childrenvo",childrenvo);
        //组装明细数据
        JSONObject childrenvoObj = new JSONObject();
        childrenvoObj.put("cinvbasid",body.getString("field0072"));//存货ID
        childrenvoObj.put("nnum",body.getString("field0077"));//数量
        childrenvoObj.put("nnotaxprice",body.getString("field0080"));//无税单价
        childrenvoObj.put("nprice",body.getString("field0082"));//含税单价
        childrenvoObj.put("nnotaxmny",body.getString("field0083"));//无税金额
        childrenvoObj.put("ntaxrate",body.getString("field0171"));//税率
        childrenvoObj.put("nmny",body.getString("field0170"));//含税金额
        childrenvo.add(childrenvoObj);
        main.put("childrenvo",childrenvo);
        String apiCode = "8000050005";
        logger.info("调拨订单请求参数：{}",sendData.toString());
        result = U8cHttpUtil.sendOATOU8CEsb(sendData.toString(),apiCode);
        return result;
    }

    /***
     * @Content:出入库申请单-盘点
     * @Author 👻👻👻👻yqh👻👻👻👻
     * @Date  2023年11月22日13:52:08
     * @Param
     * @return
     **/
    private JSONObject warehouseCheck(Map<String, Object> businessData) {
        JSONObject result = new JSONObject();
        Object mainObj = businessData.get("formmain_0218");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        Object formson_0219obj = businessData.get("formson_0219");

        //其他入库单
        Object formson_0235obj = businessData.get("formson_0235");
        JSONArray formson_0235Arr = JSON.parseArray(JSON.toJSONString(formson_0235obj));
        for(Object obj : formson_0235Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            String invId = body.getString("field0063");
            if(StrUtil.isEmpty(invId)){
                logger.info("未加载到其他出库单数据");
            }
            //组装数据推送其他出入单信息
            result = otherInWarehouse(businessDatamain,body);
        }
        //其他出库单
        JSONArray formson_0219Arr = JSON.parseArray(JSON.toJSONString(formson_0219obj));
        if(null != formson_0219Arr && formson_0219Arr.size()>0){
            for(Object obj : formson_0219Arr){
                JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
                String invId = body.getString("field0108");
                if(StrUtil.isEmpty(invId)){
                    logger.info("未加载到其他出库单数据");
                }
                //组装数据推送其他出库单信息
                result = otherOutWarehouse(businessDatamain,body);
            }
        }


        return result;
    }

    /**
     * 组装数据推送其他入库单信息
     * @param businessDatamain
     * @param body
     * @return
     */
    private JSONObject otherInWarehouse(JSONObject businessDatamain, JSONObject body) {
        JSONObject result = new JSONObject();
        JSONObject sendData = new JSONObject();
        JSONArray GeneralBillVO_4A = new JSONArray();
        sendData.put("GeneralBillVO_4A",GeneralBillVO_4A);
        JSONObject main = new JSONObject();
        GeneralBillVO_4A.add(main);
        JSONObject parentvo = new JSONObject();
        JSONArray childrenvo = new JSONArray();
        main.put("parentvo",parentvo);
        parentvo.put("pk_corp",businessDatamain.getString("field0124"));//公司
        parentvo.put("coperatorid",businessDatamain.getString("field0136"));//制单人
        parentvo.put("dbilldate",businessDatamain.getString("field0003"));//单据日期
        parentvo.put("cwarehouseid",body.getString("field0102"));//仓库
        parentvo.put("pk_calbody",body.getString("field0157"));//库存组织
        parentvo.put("cdispatcherid",businessDatamain.getString("field0128"));//收发类别
        parentvo.put("cdptid",businessDatamain.getString("field0139"));//部门
//        parentvo.put("cbizid ",businessDatamain.getString(""));//业务员
        parentvo.put("vnote",businessDatamain.getString("field0006"));//备注
        parentvo.put("vdef10",businessDatamain.getString("field0097"));//业务中心
        parentvo.put("vdef11",businessDatamain.getString("field0098"));//业务模式
        parentvo.put("vdef12",businessDatamain.getString("field0162"));//店铺
        parentvo.put("vdef13",businessDatamain.getString("field0096"));//品牌
        parentvo.put("vdef14",businessDatamain.getString("field0165"));//平台

        parentvo.put("pk_defdoc10",businessDatamain.getString("field0120"));//业务中心
        parentvo.put("pk_defdoc11",businessDatamain.getString("field0122"));//业务模式
        parentvo.put("pk_defdoc12",businessDatamain.getString("field0160"));//店铺
        parentvo.put("pk_defdoc13",businessDatamain.getString("field0118"));//品牌
        parentvo.put("pk_defdoc14",businessDatamain.getString("field0163"));//平台
        main.put("childrenvo",childrenvo);
        //组装明细数据
        JSONObject childrenvoObj = new JSONObject();
        childrenvoObj.put("bonroadflag","N");//是否在途 不知道干啥的 默认否
        childrenvoObj.put("cinventoryid",body.getString("field0109"));//存货ID
        childrenvoObj.put("flargess","N");//是否赠品，文档未标注，默认否
        childrenvoObj.put("nshouldinnum",body.getString("field0125"));//应收数量
        childrenvoObj.put("ninnum",body.getString("field0069"));//实收数量
        childrenvo.add(childrenvoObj);
        main.put("childrenvo",childrenvo);
        String apiCode = "";
        String wholemanaflag = body.getString("field0166");
        //入库：根据是否批次管理进行判断
        //			1、如果有批次管理就传递保存签字状态，同时传递一个批次号到U8C 用OA制单日期 格式为yyyyMMdd
        //			2、没有批次管理就传递签字状态
        if("Y".equals(wholemanaflag)){
            Date field0003 = businessDatamain.getDate("field0003");
            if(null != field0003){
                String vbatchcode = DateUtil.dateToString(field0003,"yyyyMMdd");
                childrenvoObj.put("vbatchcode",vbatchcode);
            }

        }
        apiCode = "8000050004";//其他入保存即签字
        logger.info("其他入库单请求数据：{}",sendData.toString());
        result = U8cHttpUtil.sendOATOU8CEsb(sendData.toString(),apiCode);
        return result;
    }

    /**
     * 组装数据推送其他出库单信息
     * @param businessDatamain
     * @param body
     * @return
     */
    private JSONObject otherOutWarehouse(JSONObject businessDatamain, JSONObject body) {
        JSONObject result = new JSONObject();
        JSONObject sendData = new JSONObject();
        JSONArray GeneralBillVO_4I = new JSONArray();
        sendData.put("GeneralBillVO_4I",GeneralBillVO_4I);
        JSONObject main = new JSONObject();
        GeneralBillVO_4I.add(main);
        JSONObject parentvo = new JSONObject();
        JSONArray childrenvo = new JSONArray();
        main.put("parentvo",parentvo);
        parentvo.put("pk_corp",businessDatamain.getString("field0124"));//公司
        parentvo.put("coperatorid",businessDatamain.getString("field0136"));//制单人
        parentvo.put("dbilldate",businessDatamain.getString("field0003"));//单据日期
        parentvo.put("cwarehouseid",body.getString("field0101"));//仓库
        parentvo.put("pk_calbody",body.getString("field0154"));//库存组织
        parentvo.put("cdispatcherid",businessDatamain.getString("field0131"));//收发类别
        parentvo.put("cdptid",businessDatamain.getString("field0139"));//部门
//        parentvo.put("cbizid ",businessDatamain.getString(""));//业务员
        parentvo.put("vdef10",businessDatamain.getString("field0097"));//业务中心
        parentvo.put("vdef11",businessDatamain.getString("field0098"));//业务模式
        parentvo.put("vdef12",businessDatamain.getString("field0162"));//店铺
        parentvo.put("vdef13",businessDatamain.getString("field0096"));//品牌
        parentvo.put("vdef14",businessDatamain.getString("field0165"));//平台

        parentvo.put("pk_defdoc10",businessDatamain.getString("field0120"));//业务中心
        parentvo.put("pk_defdoc11",businessDatamain.getString("field0122"));//业务模式
        parentvo.put("pk_defdoc12",businessDatamain.getString("field0160"));//店铺
        parentvo.put("pk_defdoc13",businessDatamain.getString("field0118"));//品牌
        parentvo.put("pk_defdoc14",businessDatamain.getString("field0163"));//平台
        main.put("childrenvo",childrenvo);
        //组装明细数据
        JSONObject childrenvoObj = new JSONObject();
        childrenvoObj.put("bonroadflag","N");//是否在途 不知道干啥的 默认否
        childrenvoObj.put("cinventoryid",body.getString("field0108"));//存货ID
        childrenvoObj.put("flargess","N");//是否赠品，文档未标注，默认否
        childrenvoObj.put("nshouldoutnum",body.getString("field0126"));//应出数量
        String apiCode = "";
        //1、出入库逻辑
        //	出库：根据是否批次管理进行判断
        //		1、如果有批次 传保存状态 传递应发  实发不不传递
        //		2、没有批次，保存即签字状态
        String field0172 = body.getString("field0172");
        if("Y".equals(field0172)){
            apiCode = "8000050013";
        }else{
            apiCode = "8000050006";
            childrenvoObj.put("noutnum",body.getString("field0058"));//实出数量
        }
//        childrenvoObj.put("noutnum","0");//实出数量
//        childrenvoObj.put("vbatchcode","20231123");//批次
        childrenvo.add(childrenvoObj);
        main.put("childrenvo",childrenvo);

        logger.info("其他出库单请求数据：{}",sendData.toString());
        result = U8cHttpUtil.sendOATOU8CEsb(sendData.toString(),apiCode);
        return result;
    }

    /**
     * 存货档案-速网
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundSWinvDoc(Map<String, Object> businessData, String formApp) {
        StringBuffer resultB = new StringBuffer();
        Object mainObj = businessData.get("formmain_0231");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        JSONObject custDoc = new JSONObject();
        JSONObject invbasdoc = new JSONObject();
        //组装主表数据
        JSONObject parentvo = new JSONObject();
        parentvo.put("pk_invcl",businessDatamain.getString("field0020"));//存货分类主键
        parentvo.put("invcode",businessDatamain.getString("field0005"));//存货编码
        parentvo.put("invname",businessDatamain.getString("field0006"));//存货名称
//        parentvo.put("def1",businessDatamain.getString("field0033"));//旺店通存货分类名称
        parentvo.put("def1",businessDatamain.getString("field0009"));//旺店通存货分类名称
//        parentvo.put("pk_defdoc1",businessDatamain.getString("field0009"));//旺店通存货分类名称
//        parentvo.put("def3",businessDatamain.getString("field0031"));//公司主键
        parentvo.put("def3",businessDatamain.getString("field0029"));//公司主键
//        parentvo.put("pk_defdoc3",businessDatamain.getString("field0029"));//公司名称
        parentvo.put("invmnecode",businessDatamain.getString("field0007"));//货品编码（spu）
        parentvo.put("def5",businessDatamain.getString("field0028"));//物料对应客商 客商主键
        parentvo.put("pk_measdoc",businessDatamain.getString("field0022"));//主计量单位
//        parentvo.put("pk_taxitems","40040000000000000082");//税目  固定传13
        parentvo.put("pk_taxitems",businessDatamain.getString("field0026"));//税目  固定传13
        parentvo.put("def6",businessDatamain.getString("field0017"));//标准零售价

        parentvo.put("invpinpai",businessDatamain.getString("field0035"));//品牌
        parentvo.put("invbarcode",businessDatamain.getString("field0060"));//条形码
        parentvo.put("graphid",businessDatamain.getString("field0061"));//品牌自带编码
        parentvo.put("def2",businessDatamain.getString("field0036"));//三级分类
        parentvo.put("def4",businessDatamain.getString("field0043"));//GIV
        parentvo.put("def5",businessDatamain.getString("field0011"));//主供应商
        parentvo.put("def12",businessDatamain.getString("field0056"));//是否专供
        parentvo.put("def7",businessDatamain.getString("field0057"));//是否在售
        parentvo.put("def8",businessDatamain.getString("field0039"));//四级分类
        parentvo.put("invshortname",businessDatamain.getString("field0053"));//存货简称
        parentvo.put("invspec",businessDatamain.getString("field0044"));//单品规格
        parentvo.put("invtype",businessDatamain.getString("field0045"));//规格码
        parentvo.put("def9",businessDatamain.getString("field0059"));//箱规1
        parentvo.put("length",businessDatamain.getString("field0047"));//长[mm]
        parentvo.put("height",businessDatamain.getString("field0048"));//高[mm]
        parentvo.put("width",businessDatamain.getString("field0049"));//宽[mm]
        parentvo.put("unitweight",businessDatamain.getString("field0050"));//单品净重[g]
        parentvo.put("def10",businessDatamain.getString("field0051"));//产地
        parentvo.put("def11",businessDatamain.getString("field0058"));//是否进口

        custDoc.put("parentvo",parentvo);
        JSONArray childrenvo = new JSONArray();
        custDoc.put("childrenvo",childrenvo);
        invbasdoc.put("invbasdoc",custDoc);
        logger.info("存货档案请求参数：{}",invbasdoc);
        JSONObject jsonObjectAttribute = U8cHttpUtil.sendOATOU8CEsb(invbasdoc.toString(), "8000050002");
        logger.info("存货档案新增即保存返回参数解析之后得到的attribute值为:{}",jsonObjectAttribute);
        resultB.append("存货档案新增："+jsonObjectAttribute);
        String success = jsonObjectAttribute.getString("status");
        if("success".equals(success)){
            JSONArray jsonArray = jsonObjectAttribute.getJSONArray("data");
            if(jsonArray.size()>0 && null!=jsonArray){
                for (Object object : jsonArray) {
                    JSONObject body = JSON.parseObject(JSON.toJSONString(object));
                    String parentvoResult = body.getString("parentvo");
                    JSONObject jsonObjectParentvo = JSONObject.parseObject(parentvoResult);
                    String pkInvbasdoc = jsonObjectParentvo.getString("pk_invbasdoc");
                    logger.info("获取到的存货档案主键为：{}",pkInvbasdoc);
                    JSONArray invbasdocvoArr = new JSONArray();
                    //查询所有公司，给每个公司都进行分配
//                    List<SeeyonEntity> seeyonEntities = seeYonDao.selectOAListByCorp(new SeeyonEntity());
//                    if(seeyonEntities.size()>0 && seeyonEntities !=null){
//                        for (SeeyonEntity seeyonEntity : seeyonEntities) {
//                            JSONObject custbasvo = new JSONObject();
//
//                        }
//                    }
                    JSONObject custbasvo = new JSONObject();
                    custbasvo.put("pk_corp","all");//公司
                    custbasvo.put("pk_measdoc","all");//所有库存组织
                    custbasvo.put("pk_invbasdoc",pkInvbasdoc.trim());//存货档案编码
                    invbasdocvoArr.add(custbasvo);
                    JSONObject sendParm = new JSONObject();
                    sendParm.put("invbasdocvo",invbasdocvoArr);
                    logger.info("存货档案分配请求参数:{}",sendParm.toString());
                    JSONObject jsonObject = U8cHttpUtil.sendOATOU8CEsb(sendParm.toString(), "8000050008");
                    logger.info("存货档案分配返回参数解析之后得到的attribute值为：{}",jsonObject);
                    return resultB.append("存货档案分配:"+jsonObject).toString();
                }
            }
            return resultB.toString();
        }
        return resultB.toString();
    }

    /**
     * 客商档案-速网
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundSWcustDoc(Map<String, Object> businessData, String formApp) {
        StringBuffer resultB = new StringBuffer();
        String result = "";
        JSONObject sourceData = new JSONObject();
        Object mainObj = businessData.get("formmain_0229");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        JSONObject custDoc = new JSONObject();
        //组装主表数据
        JSONObject parentvo = new JSONObject();
        parentvo.put("custcode",businessDatamain.getString("field0020"));//客商编号
//        parentvo.put("custcode","01.01.098");//客商编号
        parentvo.put("custname",businessDatamain.getString("field0008"));//客商名称
        parentvo.put("custprop","0");//客商类型 0 - 外部单位,1 - 内部核算单位,2 - 内部法人单位,3 - 内部渠道成员
        parentvo.put("pk_areacl",businessDatamain.getString("field0036"));//地区分类 主键
        parentvo.put("taxpayerid",businessDatamain.getString("field0023"));//纳税人登记号
        parentvo.put("custshortname",businessDatamain.getString("field0008"));//客商简称
        parentvo.put("phone1",businessDatamain.getString("field0012"));//联系人电话
        parentvo.put("linkman1",businessDatamain.getString("field0011"));//联系人

        parentvo.put("def1",businessDatamain.getString("field0061"));//省
        parentvo.put("def2",businessDatamain.getString("field0062"));//市
        parentvo.put("def3",businessDatamain.getString("field0063"));//区
        parentvo.put("def4",businessDatamain.getString("field0047"));//详细地址
        parentvo.put("mobilephone1",businessDatamain.getString("field0053"));//固定电话
        parentvo.put("legalbody",businessDatamain.getString("field0052"));//法人
        parentvo.put("def6",businessDatamain.getString("field0054"));//批准日期
        parentvo.put("def7",businessDatamain.getString("field0055"));//生效日期
        String field0072 = businessDatamain.getString("field0072");
        //todo 2024年2月28日09:10:22客户安东辉提出，如果标记为长期客户，则默认失效时间为
        if(StrUtil.isNotEmpty(field0072) && "7747067566458293711".equals(field0072)){
            String def8 = "9999-12-31";
            parentvo.put("def8",def8);//失效日期
        }else{
            parentvo.put("def8",businessDatamain.getString("field0056"));//失效日期
        }

//        parentvo.put("def9",businessDatamain.getString("field0070"));//结算币种
        parentvo.put("def10",businessDatamain.getString("field0058"));//经济类型
        parentvo.put("def11",businessDatamain.getString("field0064"));//内部联系人
        parentvo.put("def5",businessDatamain.getString("field0060"));//注册日期
        custDoc.put("parentvo",parentvo);
        JSONArray banks = new JSONArray();
        //OA银行信息存在与主表上面 ，如果银行账号不为空才设置
        if(businessDatamain.getString("field0010")!=null && !"".equals(businessDatamain.getString("field0010"))
                && businessDatamain.getString("field0037")!=null && !"".equals(businessDatamain.getString("field0037"))){
            JSONObject sendBody = new JSONObject();
            sendBody.put("accname",businessDatamain.getString("field0037"));//银行名称  传编码
            sendBody.put("account",businessDatamain.getString("field0010"));//银行账户
            sendBody.put("pk_accbank",businessDatamain.getString("field0038"));//开户行
            sendBody.put("defflag","Y");//是否默认
            sendBody.put("pk_currtype","CNY");//币种 填写编码
            sendBody.put("status","2");//修改状态  1修改 2新增 3删除
            banks.add(sendBody);
        }
        custDoc.put("banks",banks);
        sourceData.put("cbdocvo",custDoc);
        logger.info("客商档案请求参数：{}",sourceData);
        JSONObject jsonObjectAttribute = U8cHttpUtil.sendOATOU8CEsb(sourceData.toString(), "8000050003");
        logger.info("客商档案新增即保存返回参数解析之后得到的attribute值为:{}",jsonObjectAttribute);
        resultB.append("客商档案新增："+jsonObjectAttribute);
        String success = jsonObjectAttribute.getString("status");
        //传递成功之后进行分配，反之直接返回错误信息
        if ("success".equals(success)) {
            JSONArray jsonArray = jsonObjectAttribute.getJSONArray("data");
            if (jsonArray.size() > 0 && null != jsonArray) {
                for (Object object : jsonArray) {
                    JSONObject body = JSON.parseObject(JSON.toJSONString(object));
                    String parentvoResult = body.getString("parentvo");
                    JSONObject jsonObjectParentvo = JSONObject.parseObject(parentvoResult);
                    String pkCubasdoc = jsonObjectParentvo.getString("pk_cubasdoc");
                    logger.info("获取到的客商档案主键为：{}", pkCubasdoc);
                    JSONArray custbasvoArr = new JSONArray();
                    //查询所有公司，给每个公司都进行分配
                    List<SeeyonEntity> seeyonEntities = seeYonDao.selectOAListByCorp(new SeeyonEntity());
                    if (seeyonEntities.size() > 0 && seeyonEntities != null) {
                        for (SeeyonEntity seeyonEntity : seeyonEntities) {
                            JSONObject custbasvo = new JSONObject();
                            //判断OA客商类型决定分配类型到组织 客商类型 -943875574826447587 客户 -516832932909398145 供应商 5622861136659237947 客商
                            //如果未成功匹配，就只暂时不处理，让让接口报错（正常来说不存在匹配不到的情况）除非OA非必填
                            String custprop = "";
                            String custType = businessDatamain.getString("field0021");
                            if(StrUtil.isNotEmpty(custType)){
                                if("-943875574826447587".equals(custType)){
                                    custprop = "0";
                                }
                                if("-516832932909398145".equals(custType)){
                                    custprop = "1";
                                }
                                if("5622861136659237947".equals(custType)){
                                    custprop = "2";
                                }
                            }
                            custbasvo.put("custprop",custprop);//客商属性  0：客户，1：供应商，2：客商
                            custbasvo.put("pk_corp", seeyonEntity.getPk_corp().trim());//公司
                            custbasvo.put("pk_cubasdoc", pkCubasdoc.trim());//客商基本档案主键
                            custbasvoArr.add(custbasvo);
                        }
                    }
                    JSONObject sendParm = new JSONObject();
                    sendParm.put("custbasvo", custbasvoArr);
                    logger.info("客商档案分配请求参数:{}", sendParm);
                    JSONObject jsonObject = U8cHttpUtil.sendOATOU8CEsb(sendParm.toString(), "8000050007");
                    logger.info("客商档案分配返回参数解析之后得到的attribute值为:{}",jsonObject);
                    return resultB.append("客商档案分配:"+result).toString();
                }
            }
        }
        return resultB.toString();
    }

    /**
     * 采购付款单-速网
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundSWPUPy(Map<String, Object> businessData, String formApp)throws Exception {
        JSONObject result = new JSONObject();
        JSONObject data = new JSONObject();
        JSONObject sourceData = new JSONObject();
        Object mainObj = businessData.get("formmain_0209");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        JSONObject puPay = new JSONObject();
//        String dateStr = businessDatamain.getString("field0023");
        String dateStr = businessDatamain.getString("field0002");
        Date billDate = DateUtil.stringToDate(dateStr,"yyyy-MM-dd");
        String date = DateUtil.dateToString(billDate,"yyyy-MM-dd");
        //组装主表数据
        JSONObject parentvo = new JSONObject();
        parentvo.put("lrr",businessDatamain.getString("field0137"));//录入人
        parentvo.put("djlxbm","D3");//单据类型编码 field0101
        parentvo.put("dwbm",businessDatamain.getString("field0153"));//单位编码
        parentvo.put("djrq",date);//业务单据日期
        parentvo.put("shrq",date);//审核日期
        parentvo.put("deptid",businessDatamain.getString("field0161"));//部门

        parentvo.put("shr",businessDatamain.getString("field0137"));//审核人
        parentvo.put("qrr",businessDatamain.getString("field0137"));//签字确认人
        parentvo.put("ybje",businessDatamain.getString("field0019"));//原币金额
        parentvo.put("bbje",businessDatamain.getString("field0019"));//本币金额
        parentvo.put("pj_jsfs",businessDatamain.getString("field0155"));// 结算方式
        //自定义项名称
        parentvo.put("zyx1",businessDatamain.getString("field0175"));//银行档案
        parentvo.put("zyx10",businessDatamain.getString("field0150"));//业务中心
        parentvo.put("zyx11",businessDatamain.getString("field0147"));//业务模式
        parentvo.put("zyx12",businessDatamain.getString("field0138"));//店铺
        parentvo.put("zyx13",businessDatamain.getString("field0144"));//品牌
        parentvo.put("zyx14",businessDatamain.getString("field0141"));//平台


        parentvo.put("zyx1",businessDatamain.getString("field0158"));// 银行
        parentvo.put("zyx2",businessDatamain.getString("field0165"));// R其他货币资金
        parentvo.put("hbbm",businessDatamain.getString("field0157"));//客商
        parentvo.put("prepay","N");//预收付款标志  如果是随订单预付款，必须打勾这个字段 默认Y

        puPay.put("parentvo",parentvo);
        //报销信息明细表(明细表1)
        Object formson_0210obj = businessData.get("formson_0210");
        JSONArray formson_0210Arr = JSON.parseArray(JSON.toJSONString(formson_0210obj));
        //formson_0224
        JSONArray childrenvo = new JSONArray();
        String orderBillCode = "";
        String xslxbm = "";
        for(Object obj : formson_0210Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject sendBody = new JSONObject();
            orderBillCode = body.getString("field0012");//采购订单号
            xslxbm = body.getString("field0164");
            sendBody.put("billdate",date);//单据日期
            sendBody.put("fx","1");//方向
            sendBody.put("ddh",orderBillCode);//订单号
            sendBody.put("jfbbje",body.getString("field0014"));//本币金额
            sendBody.put("jfybje",body.getString("field0014"));//原币金额

            sendBody.put("hbbm",businessDatamain.getString("field0157"));//客商档案
//                    sendBody.put("ddh",vordercode);//订单号
            childrenvo.add(sendBody);
        }
        parentvo.put("xslxbm",xslxbm);//销售订单业务流程
        parentvo.put("zyx15",orderBillCode);//采购订单号
        puPay.put("children",childrenvo);
        JSONArray billvoArr = new JSONArray();
        billvoArr.add(puPay);
        JSONObject billvo = new JSONObject();
        billvo.put("billvo",billvoArr);
        logger.info("采购付款单请求参数：{}",billvo.toString());
        String apiCode = "8000050000";
        result = U8cHttpUtil.sendOATOU8CEsb(billvo.toString(),apiCode);
        logger.info("采购付款单返回参数：{}",result.toString());
        return result.toString();
    }

    /**
     * 采购订单-速网
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundSWPUOrder(Map<String, Object> businessData, String formApp) throws Exception{
        JSONObject result = new JSONObject();
        Object mainObj = businessData.get("formmain_0222");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        Object formson_0223obj = businessData.get("formson_0223");
        String parm = boundSWPUOrderMain(businessDatamain,formson_0223obj);
        //推送采购订单到U8C
        String apiCode = "8000050009";
        logger.info("采购订单推送参数：{}",parm);
        result = U8cHttpUtil.sendOATOU8CEsb(parm,apiCode);
        logger.info("采购订单返回参数：{}",result);
        //判断该采购订单是否随订单进行付款
        String field0065 = businessDatamain.getString("field0065");
        String status = result.getString("status");
        if(StrUtil.isNotEmpty(field0065) && "1".equals(field0065)){
            if(!"falied".equals(status)){
                try {
                    Object formson_0224obj = businessData.get("formson_0224");
                    String parmPay = boundSWPUOrderMainPay(businessDatamain,formson_0224obj,result);
                    apiCode = "8000050000";
                    logger.info("采购付款单请求参数：{}",parmPay);
                    result = U8cHttpUtil.sendOATOU8CEsb(parmPay,apiCode);
                    logger.info("采购付款单返回参数：{}",result);
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }else {
                logger.info("采购订单传递失败：{}",result.getString("errormsg"));
            }
        }
        return result.toString();
    }
    //付款单信息
    private String boundSWPUOrderMainPay(JSONObject businessDatamain, Object formson_0224obj,JSONObject attribute)throws Exception{
        JSONObject main = new JSONObject();
        JSONObject puPay = new JSONObject();
        JSONArray billvo = new JSONArray();
        String failed = attribute.getString("failed");

        JSONArray dataArr = attribute.getJSONArray("data");
        for(Object data:dataArr){
            JSONObject dataObj = JSON.parseObject(data.toString());
            JSONObject resultParentvo = dataObj.getJSONObject("parentvo");
            String corderid = resultParentvo.getString("corderid");
            String vordercode = resultParentvo.getString("vordercode");
            String dateStr = businessDatamain.getString("field0004");
            Date billDate = DateUtil.stringToDate(dateStr,"yyyy-MM-dd");
            String date = DateUtil.dateToString(billDate,"yyyy-MM-dd");
            //组装主表数据
            JSONObject parentvo = new JSONObject();
            parentvo.put("lrr",businessDatamain.getString("field0082"));//录入人
            parentvo.put("djlxbm","D3");//单据类型编码 field0101
            parentvo.put("dwbm",businessDatamain.getString("field0101"));//单位编码
            parentvo.put("djrq",date);//业务单据日期
            parentvo.put("shrq",date);//审核日期
//                parentvo.put("xslxbm",businessDatamain.getString("field0118"));//业务流程

            parentvo.put("shr",businessDatamain.getString("field0082"));//审核人
            parentvo.put("qrr",businessDatamain.getString("field0082"));//签字确认人
            parentvo.put("ybje",businessDatamain.getString("field0017"));//原币金额
            parentvo.put("bbje",businessDatamain.getString("field0017"));//本币金额
            parentvo.put("pj_jsfs",businessDatamain.getString("field0128"));// 结算方式
            parentvo.put("deptid",businessDatamain.getString("field0109"));// 部门
            parentvo.put("bzbm",businessDatamain.getString("field0113"));// 币种
            //自定义项名称
            parentvo.put("zyx1",businessDatamain.getString("field0198"));//银行档案
            parentvo.put("zyx10",businessDatamain.getString("field0093"));//业务中心
            parentvo.put("zyx11",businessDatamain.getString("field0096"));//业务模式
            parentvo.put("zyx12",businessDatamain.getString("field0087"));//店铺
            parentvo.put("zyx13",businessDatamain.getString("field0090"));//品牌
            parentvo.put("zyx14",businessDatamain.getString("field0084"));//平台
            parentvo.put("zyx15",vordercode);//采购订单号

            parentvo.put("zyx1",businessDatamain.getString("field0131"));// 银行
            parentvo.put("zyx2",businessDatamain.getString("field0161"));// 其他货币资金
            parentvo.put("hbbm",businessDatamain.getString("field0134"));//客商
            parentvo.put("prepay","Y");//预收付款标志  如果是随订单预付款，必须打勾这个字段 默认Y

            puPay.put("parentvo",parentvo);
            JSONObject sendBody = new JSONObject();
            sendBody.put("billdate",date);//单据日期
            sendBody.put("fx","1");//方向
//                sendBody.put("jfbbje",businessDatamain.getString("field0066"));//本币金额
            sendBody.put("jfybje",businessDatamain.getString("field0066"));//原币金额
            JSONArray childrenvo = new JSONArray();
            sendBody.put("ddlx",corderid);//来源单据id
//              sendBody.put("ddhh",corder_bid);//来源单据行id
            sendBody.put("hbbm",businessDatamain.getString("field0134"));//客商档案
            sendBody.put("ddh",vordercode);//订单号
            childrenvo.add(sendBody);
            //报销信息明细表(明细表1)
//                JSONArray formson_0224Arr = JSON.parseArray(JSON.toJSONString(formson_0224obj));
            //formson_0224
//                JSONArray childrenvo = new JSONArray();
//                for(Object obj : formson_0224Arr){
//                    JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
//                    //如果付款原币金额为空，则不传递当前明细行，杜绝有空行存在
//                    if(StrUtil.isEmpty(body.getString("field0054"))){
//                        continue;
//                    }
//
//                }
            puPay.put("children",childrenvo);
//            }

        }
        billvo.add(puPay);
        main.put("billvo",billvo);
        return main.toString();
    }

    //采购订单信息
    private String boundSWPUOrderMain(JSONObject businessDatamain,Object formson_0223obj)throws Exception{
        JSONObject data = new JSONObject();
        JSONObject sourceData = new JSONObject();

        JSONObject puOrder = new JSONObject();
        //组装主表数据
        JSONObject parentvo = new JSONObject();
        parentvo.put("cbiztype",businessDatamain.getString("field0118"));//业务流程
        parentvo.put("cdeptid",businessDatamain.getString("field0109"));//采购部门
//        parentvo.put("cdeptid","1007F81000000000K1Q0");//采购部门-速网先默认 用完注释
        parentvo.put("coperator",businessDatamain.getString("field0082"));//制单人
        //采购组织
        BdCorpEntity poCorp = new BdCorpEntity();
        String pkCorp = businessDatamain.getString("field0101");
//        String poCode = businessDatamain.getString("field0122");
//        if(StrUtil.isNotEmpty(pkCorp) && StrUtil.isNotEmpty(poCode)){
//            poCorp.setPkCorp(pkCorp);
//            poCorp.setCode(poCode);
//            poCorp = corpService.getPoPkByOrg(poCorp);
//            if(null != poCorp){
//                parentvo.put("cpurorganization",poCorp.getPkPurorg());//采购组织
//            }
//        }
        parentvo.put("cpurorganization",businessDatamain.getString("field0121"));//采购组织
        parentvo.put("cvendormangid",businessDatamain.getString("field0103"));//供应商
        parentvo.put("pk_corp",pkCorp);//所属公司
        parentvo.put("vordercode",businessDatamain.getString("field0112"));//订单编号
        parentvo.put("dorderdate",businessDatamain.getString("field0004"));//订单日期
        parentvo.put("vmemo",businessDatamain.getString("field0025"));//备注

//        if("0001F81000000000IGUU".equals(businessDatamain.getString("field0195"))){
//            parentvo.put("pk_defdoc18", businessDatamain.getString("field0201"));//是否补单主键
//            parentvo.put("vdef18", "是");//是否补单主键
//        }
//        if("0001F81000000000IGUV".equals(businessDatamain.getString("field0195"))){
//            parentvo.put("pk_defdoc18", businessDatamain.getString("field0195"));//是否补单主键
//            parentvo.put("vdef18", "否");//是否补单主键
//        }
        //自定义项主键
        parentvo.put("pk_defdoc10",businessDatamain.getString("field0093"));//业务中心
        parentvo.put("pk_defdoc11",businessDatamain.getString("field0096"));//业务模式
        parentvo.put("pk_defdoc12",businessDatamain.getString("field0087"));//店铺
        parentvo.put("pk_defdoc13",businessDatamain.getString("field0090"));//品牌
        parentvo.put("pk_defdoc14",businessDatamain.getString("field0084"));//平台
        parentvo.put("pk_defdoc15",businessDatamain.getString("field0155"));//收货仓库主键
        //自定义项名称
        parentvo.put("vdef10",businessDatamain.getString("field0095"));//业务中心
        parentvo.put("vdef11",businessDatamain.getString("field0098"));//业务模式
        parentvo.put("vdef12",businessDatamain.getString("field0089"));//店铺
        parentvo.put("vdef13",businessDatamain.getString("field0092"));//品牌
        parentvo.put("vdef14",businessDatamain.getString("field0086"));//平台
        parentvo.put("vdef15",businessDatamain.getString("field0155"));//收货仓库名称
        parentvo.put("ccurrencytypeid",businessDatamain.getString("field0113"));//原币币种ID


        puOrder.put("parentvo",parentvo);
        //报销信息明细表(明细表1)

        JSONArray formson_0223Arr = JSON.parseArray(JSON.toJSONString(formson_0223obj));
        //formson_0205
        JSONArray childrenvo = new JSONArray();
        for(Object obj : formson_0223Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject sendBody = new JSONObject();
            sendBody.put("pk_corp",body.getString("field0043"));//公司主键
            sendBody.put("vdef1",body.getString("field0154"));//折扣一金额
            //通过所属公司与存货编码获取存货管理档案主键
            BdInvmandocEntity invmandoc = new BdInvmandocEntity();
            invmandoc.setInvcode(body.getString("field0104"));
            invmandoc.setPkCorp(pkCorp);
            List<BdInvmandocEntity> bdInvmandocEntityList = invmandocDao.queryBdInvmandocByInvcode(invmandoc);
            if(null != bdInvmandocEntityList && bdInvmandocEntityList.size()>0 ){
                for(BdInvmandocEntity inv : bdInvmandocEntityList){
                    String pkInvmandoc = inv.getPkInvmandoc();
                    if(null != invmandoc){
                        sendBody.put("cmangid",pkInvmandoc);//存货信息
                        break;
                    }
                }

            }
            String fale = "Y";
            logger.info("是否赠品:{}",body.getString("field0197"));
            if ("2544055901016641496".equals(body.getString("field0197")) || null ==body.getString("field0197")) { //否
                fale = "N";
            }
            sendBody.put("blargess", fale);//是否赠品 N Y

//            //获取收货库存组织主键
            String stockCode = body.getString("field0125");
            if(StrUtil.isNotEmpty(pkCorp) && StrUtil.isNotEmpty(stockCode)){
//                poCorp.setPkCorp(pkCorp);
                poCorp.setCode(stockCode);
                poCorp = corpService.getStockPkByOrg(poCorp);
                if(null != poCorp){
                    sendBody.put("pk_arrvcorp",poCorp.getPkCorp());//收货公司
                    sendBody.put("pk_arrvstoorg",poCorp.getPkCalbody());//收货库存组织
                }
            }
            sendBody.put("ntaxrate",body.getString("field0135"));//税率
//            sendBody.put("pk_arrvstoorg",body.getString("field0126"));//收货库存组织
            sendBody.put("ccurrencytypeid",businessDatamain.getString("field0113"));//原币币种ID
            sendBody.put("nordernum",body.getString("field0028"));//订货数量
            sendBody.put("norgtaxprice",body.getString("field0117"));//原币含税单价
            sendBody.put("noriginalcurprice",body.getString("field0116"));//原币无税单价
            sendBody.put("cwarehouseid",body.getString("field0116"));//原币无税单价
            childrenvo.add(sendBody);
        }
        puOrder.put("childrenvo",childrenvo);
        sourceData.put("puordervo",puOrder);
//        logger.info("采购订单请求参数：{}",sourceData);
        return sourceData.toString();
    }

    /**
     * 销售订单-速网
     * @param businessData
     * @param formApp
     * @return
     */
    private String boundSWSaleOrder(Map<String, Object> businessData, String formApp) {
        try {
            Object mainObj = businessData.get("formmain_0202");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject jsonObject=new JSONObject();
            //判断单子是否是退货订单  1:是  0：否
            if("0".equals(businessDatamain.getString("field0105"))){
                jsonObject= boundSWSaleOrderMerge(businessData,"N");
            }else {
                jsonObject= boundSWSaleOrderMerge(businessData, "Y");
                if ("success".equals(jsonObject.getString("status"))) {
                    //销售订单关闭
                    boundSWSaleGeneral(businessData);
                }
            }
            return jsonObject.toString();
        }catch (Exception e){
            e.printStackTrace();
            logger.info("销售订单操作失败:{}",e.getMessage());
        }
        return null;
    }

    private JSONObject boundSWSaleOrderMerge(Map<String, Object> businessData,String type)throws Exception {
        StringBuffer stringBuffer=new StringBuffer();
        JSONObject sourceData = new JSONObject();
        Object mainObj = businessData.get("formmain_0202");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        String id = businessDatamain.getString("id");//oaid
        String field0010= businessDatamain.getString("field0010");
        JSONObject saleorder = new JSONObject();
        String pkCorp = businessDatamain.getString("field0112");
        //组装主表数据
        JSONObject parentvo = new JSONObject();
        parentvo.put("vdef12", businessDatamain.getString("field0074"));//店铺 名称
        parentvo.put("pk_defdoc12", businessDatamain.getString("field0108"));//店铺 主键
        parentvo.put("vdef2", businessDatamain.getString("field0075"));//收件人姓名
        parentvo.put("vdef3", businessDatamain.getString("field0076"));//收件人手机
        parentvo.put("vdef4", businessDatamain.getString("field0077"));//邮费
        parentvo.put("vdef8", businessDatamain.getString("field0081"));//地址
        parentvo.put("vdef9", businessDatamain.getString("field0149"));//送样类型
        parentvo.put("vdef17", businessDatamain.getString("field0210"));//销售折让
        parentvo.put("vreceiptcode",field0010);//单据号
        parentvo.put("cbiztype", businessDatamain.getString("field0132"));//业务类型  主键
        parentvo.put("dbilldate", businessDatamain.getString("field0002"));//单据日期
        parentvo.put("pk_corp",pkCorp );//所属公司编码 主键
        //客户主键，需要通过所属公司以及客户编码获取客户管理档案主键
        String custCode = businessDatamain.getString("field0109");
        BdCumandocEntity cumandoc = new BdCumandocEntity();
        cumandoc.setPkCorp(pkCorp);
        cumandoc.setCustcode(custCode);
        List<BdCumandocEntity>bdCumandocEntityList = bdCumandocDao.selectIdByCodeAndCorp(cumandoc);
        if(null != bdCumandocEntityList && bdCumandocEntityList.size()>0){
            for(BdCumandocEntity bdCumandocEntity : bdCumandocEntityList){
                if(null != bdCumandocEntity){
                    String cumandocId = bdCumandocEntity.getPkCumandoc();
                    parentvo.put("ccustomerid", cumandocId);//客户编码 主键
                }
            }
        }
        parentvo.put("cdeptid", businessDatamain.getString("field0142"));//执行部门 主键
        parentvo.put("csalecorpid", businessDatamain.getString("field0137"));//销售组织 主键不能为空
        parentvo.put("ccalbodyid", businessDatamain.getString("field0202"));//库存组织  主键//todo
//        parentvo.put("ccalbodyid", "1007F81000000000JEGU");//库存组织  主键//todo 等待修改
        parentvo.put("creceiptcorpid", businessDatamain.getString("field0110"));//开票单位 客户主键
        parentvo.put("ndiscountrate", businessDatamain.getString("field0093"));//整单折扣
        parentvo.put("bretinvflag", type);//退货标记 N Y
        parentvo.put("vnote", businessDatamain.getString("field0188"));//备注
        parentvo.put("coperatorid", businessDatamain.getString("field0129"));//制单人 主键
        parentvo.put("vdef10", businessDatamain.getString("field0091"));//业务中心 名称
        parentvo.put("vdef9", businessDatamain.getString("field0149"));//送样类型 名称
        parentvo.put("vdef11", businessDatamain.getString("field0095"));//业务模式 名称
        parentvo.put("vdef13", businessDatamain.getString("field0096"));//品牌 名称
        parentvo.put("vdef14", businessDatamain.getString("field0097"));//平台 名称

        parentvo.put("vdef15", businessDatamain.getString("field0146"));//原单单号
        parentvo.put("vdef16", businessDatamain.getString("field0131"));//原单主键

//        if("0001F81000000000IGUU".equals(businessDatamain.getString("field0201"))){
//            parentvo.put("pk_defdoc18", businessDatamain.getString("field0201"));//是否补单主键
//            parentvo.put("vdef18", "是");//是否补单主键
//        }
//        if("0001F81000000000IGUV".equals(businessDatamain.getString("field0201"))){
//            parentvo.put("pk_defdoc18", businessDatamain.getString("field0201"));//是否补单主键
//            parentvo.put("vdef18", "否");//是否补单主键
//        }

        parentvo.put("pk_defdoc10", businessDatamain.getString("field0125"));//业务中心 主键
        parentvo.put("pk_defdoc9", businessDatamain.getString("field0147"));//送样类型 主键
        parentvo.put("pk_defdoc11", businessDatamain.getString("field0123"));//业务模式 主键
        parentvo.put("pk_defdoc13", businessDatamain.getString("field0120"));//品牌 主键
        parentvo.put("pk_defdoc14", businessDatamain.getString("field0122"));//平台 主键
        if(StrUtil.isNotEmpty(businessDatamain.getString("field0155"))){
            parentvo.put("vdef5",businessDatamain.getString("field0155"));//省
        }else{
            parentvo.put("vdef5","无");//省
        }
        if(StrUtil.isNotEmpty(businessDatamain.getString("field0156"))){
            parentvo.put("vdef6",businessDatamain.getString("field0156"));//市
        }else{
            parentvo.put("vdef6","无");//市
        }
        if(StrUtil.isNotEmpty(businessDatamain.getString("field0157"))){
            parentvo.put("vdef7",businessDatamain.getString("field0157"));//区/县
        }else {
            parentvo.put("vdef7","无");//区/县
        }


        parentvo.put("vdef8",businessDatamain.getString("field0081"));//详细地址

        saleorder.put("parentvo", parentvo);
        //报销信息明细表(明细表1)
        Object formson_0203obj = businessData.get("formson_0203");
        JSONArray childrenvo = new JSONArray();
        JSONArray formson_0203Arr = JSON.parseArray(JSON.toJSONString(formson_0203obj));
        if (formson_0203Arr.size() > 0 && null != formson_0203Arr) {
            for (Object obj : formson_0203Arr) {
                JSONObject body = JSON.parseObject(JSON.toJSONString(obj));
                JSONObject sendBody = new JSONObject();
                //通过所属公司与存货编码获取存货管理档案主键
                BdInvmandocEntity invmandoc = new BdInvmandocEntity();
                invmandoc.setInvcode(body.getString("field0012"));
                if(StrUtil.isNotEmpty(businessDatamain.getString("field0177"))){
                    invmandoc.setPkCorp(businessDatamain.getString("field0177"));//todo 2024年1月24日09:51:27 实施提出需要将存货传递为库存公司的管理主键
                }else {
                    invmandoc.setPkCorp(pkCorp);
                }

                List<BdInvmandocEntity> bdInvmandocEntityList = invmandocDao.queryBdInvmandocByInvcode(invmandoc);
                if(null != bdInvmandocEntityList && bdInvmandocEntityList.size()>0 ){
                    for(BdInvmandocEntity inv : bdInvmandocEntityList){
                        String pkInvmandoc = inv.getPkInvmandoc();
                        if(null != invmandoc){
                            sendBody.put("cinventoryid", pkInvmandoc);//存货编码 主键
                            break;
                        }
                    }

                }
                sendBody.put("cunitid", body.getString("field0116"));//单位
                sendBody.put("creccalbodyid", body.getString("field0202"));//收货库存组织
//                sendBody.put("creccalbodyid", "1007F81000000000JEGU");//收货库存组织

                if(StrUtil.isNotEmpty(businessDatamain.getString("field0177"))&&!businessDatamain.getString("field0177").equals(pkCorp)){
                    sendBody.put("cconsigncorpid", businessDatamain.getString("field0177"));//发货公司
                }
                if("0".equals(businessDatamain.getString("field0105"))){
                    sendBody.put("nnumber", body.getString("field0018"));//数量
                }else{
                    sendBody.put("nnumber", "-"+body.getString("field0018"));//数量
                }
                String fale = "Y";
                logger.info("是否赠品:{}",body.getString("field0023"));
                if ("1289206401434863591".equals(body.getString("field0023")) || null ==body.getString("field0023")) { //否
                    fale = "N";
                }
                sendBody.put("blargessflag", fale);//是否赠品 N Y
                sendBody.put("noriginalcurprice", body.getString("field0139"));//不含税单价
                String field0182 = body.getString("field0182");
                if("是".equals(field0182)){
                    sendBody.put("blargessflag", "Y");//是否赠品
                }
                sendBody.put("ntaxrate", "13%");//税率
                sendBody.put("noriginalcurtaxprice", body.getString("field0168"));//含税单价
                //sendBody.put("noriginalcursummny", body.getString("field0082"));//原币价税合计
                sendBody.put("cbodywarehouseid", body.getString("field0114"));//附表仓库
                sendBody.put("cadvisecalbodyid",businessDatamain.getString("field0136"));//发货库存组织 主键
                sendBody.put("vostatus", body.getString("new"));//状态 调用修改接口时使用，传值：修改时update、删除时delete、新增时new）

                childrenvo.add(sendBody);
            }
        }
            saleorder.put("childrenvo", childrenvo);
            sourceData.put("saleorder", saleorder);
            logger.info("销售订单保存即审核请求参数：{}", sourceData);
            JSONObject jsonObjectAttribute = U8cHttpUtil.sendOATOU8CEsb(sourceData.toString(), "8000050001");
            logger.info("销售订单保存即审核返回参数解析之后得到的attribute值为:{}", jsonObjectAttribute);
            stringBuffer.append("销售订单保存即审核:" + jsonObjectAttribute);
            SeeyonEntity seeyon = new SeeyonEntity();
            String success = jsonObjectAttribute.getString("status");
            if ("success".equals(success)) {
                JSONArray jsonArray = jsonObjectAttribute.getJSONArray("data");
                if (jsonArray.size() > 0 && null != jsonArray) {
                    for (Object object : jsonArray) {
                        JSONObject body = JSON.parseObject(JSON.toJSONString(object));
                        String parentvoResult = body.getString("parentvo");
                        JSONObject jsonObjectParentvo = JSONObject.parseObject(parentvoResult);
                        String csaleid = jsonObjectParentvo.getString("csaleid");
                        logger.info("获取到的销售订单主键为：{}", csaleid);
                        String corderBid=null;
                        String inventoryCode=null;
                        String childrenvoDetsils = body.getString("childrenvo");
                        JSONArray jsonArrayDetails = JSONArray.parseArray(childrenvoDetsils);
                        if (jsonArrayDetails.size() > 0 && null != jsonArrayDetails) {
                            for (Object jsonArrayDetail : jsonArrayDetails) {
                                JSONObject details = JSON.parseObject(JSON.toJSONString(jsonArrayDetail));
                                 corderBid = details.getString("corder_bid");
                                 inventoryCode = details.getString("inventory_code");//存货编码
                                logger.info("获取到的销售订单明细主键为：{},存货编码为:{}", corderBid,inventoryCode);
                                //根据销售订单单据编号查询销售订单档案主键id
                                seeyon.setField0010(field0010);
                                SeeyonEntity seeyonEntity = seeYonDao.selectOAListByformmain_0237(seeyon);
                                if(null !=seeyonEntity){
                                    //更新OA销售订单档案明细
                                    seeyon.setField0121(corderBid);
                                    seeyon.setFormmain_id(seeyonEntity.getDa_id());
                                    seeyon.setField0012(inventoryCode);
                                    seeYonDao.updateFormformson_0238(seeyon);
                                }
                            }
                        }
                        //更新OA销售订单档案
                        seeyon.setField0120(csaleid);
                        seeyon.setField0010(field0010);
                        seeYonDao.updateFormformmain_0237(seeyon);
                    }
                }
            } else {
                //更新OA销售订单档案
                seeyon.setField0120("2");
                seeyon.setField0010(field0010);
                seeYonDao.updateFormformmain_0237(seeyon);
            }
            return jsonObjectAttribute;
    }

    /**
     *
     * @content 销售订单关闭
     * @Param
     * @Return
     * @Author hecan
     * @Date 2023/11/13 14:19
     * **/
    private String boundSWSaleGeneral(Map<String,Object> businessData) {
        Object mainObj = businessData.get("formmain_0202");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        JSONObject saleGeneral = new JSONObject();
        //组装关闭信息
        JSONObject closeinfo = new JSONObject();
        closeinfo.put("coperator",businessDatamain.get("field0128"));//操作员编码
        closeinfo.put("date_closeoropen",businessDatamain.get(""));//关闭/打开日期
        //组装查询信息
        JSONObject queryinfo = new JSONObject();
        queryinfo.put("code",businessDatamain.get("field0010"));//单据号
        queryinfo.put("corp",businessDatamain.get("field0111"));//公司编码
        queryinfo.put("date_begin",businessDatamain.get("field0002"));//单据开始日期
        queryinfo.put("date_end",businessDatamain.get("field0002"));//单据结束日期
        queryinfo.put("inventory",businessDatamain.get(""));//存货
        queryinfo.put("maker",businessDatamain.get(""));//制单人
        queryinfo.put("vendor",businessDatamain.get(""));//供应商
        saleGeneral.put("closeinfo",closeinfo);
        saleGeneral.put("queryinfo",queryinfo);
        //明细表 行关闭信息
        JSONArray rowCloseOpenInfo = new JSONArray();
        Object formson_0203obj = businessData.get("formson_0203");
        JSONArray detailsArr = JSON.parseArray(JSON.toJSONString(formson_0203obj));
        if(detailsArr.size() > 0 && detailsArr!= null) {
            for (Object obj : detailsArr) {
                JSONObject body = JSON.parseObject(JSON.toJSONString(obj));
                JSONObject sendBody = new JSONObject();
                sendBody.put("bifinventoryfinish", body.getString(""));//是否出库关闭
                sendBody.put("bifinvoicefinish", body.getString(""));//是否开票关闭
                sendBody.put("bifreceivefinish", body.getString(""));//是否发货关闭
                sendBody.put("bsquareendflag", body.getString(""));//是否结算关闭
                sendBody.put("crowno", body.getString(""));//表体行号（非整单关闭打开时必传）
                sendBody.put("incoconfclose", body.getString(""));//是否收入确认关闭
                sendBody.put("isRowClose", body.getString(""));//是否行关闭
                rowCloseOpenInfo.add(sendBody);
            }
        }
        saleGeneral.put("rowCloseOpenInfo",rowCloseOpenInfo);
        logger.info("销售订单关闭请求参数：{}",saleGeneral);
        String result = HttpRequest.post(baseUrl)
                .header("usercode", "tbadmin")//头信息，多个头信息多次调用此方法即可
                .header("password", "c4ca4238a0b923820dcc509a6f75849b")//头信息，多个头信息多次调用此方法即可
                .header("trantype", "code")//头信息，多个头信息多次调用此方法即可
                .header("system", "SOWOW")//头信息，多个头信息多次调用此方法即可
                .header("appId", "800005")//头信息，多个头信息多次调用此方法即可
                .header("apiCode", "8000050011")//头信息，多个头信息多次调用此方法即可
                .header("publicKey", "ZJYAWb7lhAUTYqekPkU+uHJv1/ObJxb7dT7sD8HPRDGAgyhCe7eDIk+3zDUT+v578prj")//头信息，多个头信息多次调用此方法即可
                .header("secretKey", "fviZnLBsQUAGF8w8FSOdJi7XlIm/XAZclMxRagDLfTyJFlvnIBF3w66Hrpfzs8cYj3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")//头信息，多个头信息多次调用此方法即可
                .body(saleGeneral.toString())//表单内容
                .timeout(20000)//超时，毫秒
                .execute().body();
        logger.info("销售订单关闭返回参数：{}",result);
        return result;
    }

    /**
     * 日常费用报销单
     * @param businessData
     * @param formApp
     * @return
     */
    private JSONObject boundDatacurrentExpense(Map<String, Object> businessData, String formApp) {
        JSONObject data = new JSONObject();
        Object mainObj = businessData.get("formmain_0314");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        //todo 所有日期传递时间戳
        //组装主表数据
        JSONObject main = new JSONObject();
        main.put("textField_lm5r47lv",businessDatamain.get("field0220"));//单据编号
        main.put("textField_lm5r47lx",businessDatamain.get("field0228"));//公司编码
        JSONArray field0275Arr = new JSONArray();
        String field0275 = businessDatamain.get("field0275").toString();
        field0275Arr.add(field0275);

        main.put("employeeField_lm5r47lz",field0275Arr);//申请人
        main.put("dateField_lm5r47m0",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0125"))));//申请日期

        JSONArray field0290Arr = new JSONArray();
        String field0290 = businessDatamain.get("field0290").toString();
        field0290Arr.add(field0290);

        main.put("departmentSelectField_lm5r47m2",field0290Arr);//申请人部门
        main.put("textField_lm5r47m4",businessDatamain.get("field0188"));//入账公司
        main.put("textField_lm5r47m6",businessDatamain.get("field0187"));//申请人电话
        main.put("textField_lm5r47m8",businessDatamain.get("field0277"));//是否有借款
        main.put("textField_lm5r47ma",businessDatamain.get("field0199"));//申请说明
        main.put("textField_lm5r47mc",businessDatamain.get("field0230"));//费用预算年度
        main.put("textField_lm5r47me",businessDatamain.get("field0250"));//付款金额合计大写
        main.put("textField_lm5r47mg",businessDatamain.get("field0251"));//报销金额合计大写
        main.put("numberField_lm5r47mh",businessDatamain.get("field0252"));//报销金额合计小写
        main.put("numberField_lm5r47mj",businessDatamain.get("field0253"));//付款金额合计小写

        //报销信息明细表(明细表1)
        Object formson_0315obj = businessData.get("formson_0315");
        JSONArray formson_0315Arr = JSON.parseArray(JSON.toJSONString(formson_0315obj));
        //formson_0315
        JSONArray tableField_lm5r47mkArr = new JSONArray();
        for(Object obj : formson_0315Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5r47mk = new JSONObject();
            tableField_lm5r47mk.put("textField_lm5r47mm",body.getString("field0201"));//费用类别一级
            tableField_lm5r47mk.put("numberField_lm5r47mo",body.getString("field0237"));//年度当前可用余额
            tableField_lm5r47mk.put("numberField_lm5r47mq",body.getString("field0203"));//报销金额
            tableField_lm5r47mk.put("numberField_lm5r47ms",body.getString("field0204"));//不含税金额
            tableField_lm5r47mk.put("textField_lm5r47mu",body.getString("field0238"));//费用归属部门
            tableField_lm5r47mk.put("textField_lm5r47mw",body.getString("field0239"));//预算组织
            tableField_lm5r47mk.put("textField_lm5r47my",body.getString("field0240"));//项目
            tableField_lm5r47mk.put("textField_lm5r47n0",body.getString("field0242"));//备注
            tableField_lm5r47mk.put("textField_lm5r47n2",body.getString("field0243"));//年度费用预算ID
            tableField_lm5r47mk.put("textField_lm5r47n4",body.getString("field0244"));//预算状态
            tableField_lm5r47mk.put("textField_lm5r47n6",body.getString("field0245"));//项目编码
            tableField_lm5r47mk.put("textField_lm5r47n8",body.getString("field0246"));//费用类别ID
            tableField_lm5r47mk.put("attachmentField_lm5r47na",null);//发票上传
            tableField_lm5r47mk.put("textField_lm5r47nc",body.getString("field0256"));//票据编码
            tableField_lm5r47mk.put("textField_lm5r47ne",body.getString("field0257"));//费用名称
            tableField_lm5r47mk.put("textField_lm5r47ng",body.getString("field0258"));//发票号码
            tableField_lm5r47mk.put("numberField_lm5r47ni",body.getString("field0259"));//税率
            tableField_lm5r47mk.put("numberField_lm5r47nk",body.getString("field0260"));//税额
            tableField_lm5r47mk.put("textField_lm5r47nm",body.getString("field0261"));//费用类别二级
            tableField_lm5r47mk.put("textField_lm5okztj",body.getString("field0262"));//乘车人
            tableField_lm5r47mk.put("dateField_lm5okztl",DateUtil.dateStrToLong(String.valueOf(body.get("field0263"))));//日期
            tableField_lm5r47mk.put("dateField_lm5okztn",DateUtil.dateStrToLong(String.valueOf(body.get("field0264"))));//开始时间
            tableField_lm5r47mk.put("dateField_lm5okztp",DateUtil.dateStrToLong(String.valueOf(body.get("field0265"))));//到达时间
            tableField_lm5r47mk.put("numberField_lm5okztr",body.getString("field0266"));//发票金额
            tableField_lm5r47mk.put("textField_lm5okztt",body.getString("field0267"));//报销明细序号

            tableField_lm5r47mkArr.add(tableField_lm5r47mk);
            main.put("tableField_lm5r47mk",tableField_lm5r47mkArr);
        }


        //汇款信息明细表(明细表2)
        Object formson_0317obj = businessData.get("formson_0317");
        JSONArray formson_0317Arr = JSON.parseArray(JSON.toJSONString(formson_0317obj));
        //formson_0317

        JSONArray tableField_lm5r47nnArr = new JSONArray();
        for(Object obj : formson_0317Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5r47nn = new JSONObject();
            tableField_lm5r47nn.put("textField_lm5okztv",body.getString("field0213"));//汇款信息序号
            tableField_lm5r47nn.put("textField_lm5okztx",body.getString("field0214"));//付款方式
            tableField_lm5r47nn.put("numberField_lm5okztz",body.getString("field0215"));//付款金额
            tableField_lm5r47nn.put("textField_lm5okzu1",body.getString("field0268"));//付款方开户名称
            tableField_lm5r47nn.put("textField_lm5okzu3",body.getString("field0269"));//付款方账号
            tableField_lm5r47nn.put("textField_lm5okzu7",body.getString("field0216"));//收款人开户名称
            tableField_lm5r47nn.put("textField_lm5okzu9",body.getString("field0217"));//收款人账号

            tableField_lm5r47nnArr.add(tableField_lm5r47nn);
            main.put("tableField_lm5r47nn",tableField_lm5r47nnArr);
        }


        data.put("formDataJson",main.toString());
        data.put("userId",businessDatamain.get("field0275"));
        data.put("appType","APP_LLACU34DHTK2F07IEYVB");
        data.put("systemToken","IT5662C1PXUCS1NV6E40B61DNPLQ2PL30AQKLVA");
        data.put("formUuid","FORM-J1A66U81Y9ZD0ELKCXNT5DV0A4L83MJK3R5MLQ");
        return data;
    }

    /**
     * 招待费报销单
     * @param businessData
     * @param formApp
     * @return
     */
    private JSONObject boundDataEntertain(Map<String, Object> businessData, String formApp) {
        JSONObject data = new JSONObject();
        //todo 所有日期传递时间戳
        Object mainObj = businessData.get("formmain_0294");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        //组装主表数据
        JSONObject main = new JSONObject();
        main.put("textField_lm5okzr8",businessDatamain.get("field0093"));//关联招待申请单
        main.put("textField_lm5okzra",businessDatamain.get("field0053"));//单据编号
        JSONArray field0157Arr = new JSONArray();
        String field0157 = businessDatamain.get("field0157").toString();
        field0157Arr.add(field0157);

        main.put("employeeField_lm5okzrc",field0157Arr);//申请人
        main.put("dateField_lm5okzre",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0041"))));//申请日期
        JSONArray field0172Arr = new JSONArray();
        String field0172 = businessDatamain.get("field0172").toString();
        field0172Arr.add(field0172);

        main.put("departmentSelectField_lm5okzrg",field0172Arr);//申请人部门
        main.put("textField_lm5okzri",businessDatamain.get("field0080"));//入账公司
        main.put("textField_lm5okzrk",businessDatamain.get("field0081"));//申请人电话
        main.put("textField_lm5okzrm",businessDatamain.get("field0082"));//客户单位
        main.put("textField_lm5okzro",businessDatamain.get("field0083"));//客户人数
        main.put("textField_lm5okzrq",businessDatamain.get("field0084"));//陪同人数
        main.put("textField_lm5okzrs",businessDatamain.get("field0089"));//招待标准
        main.put("textField_lm5okzru",businessDatamain.get("field0090"));//报销说明
        main.put("numberField_lm5okzrw",businessDatamain.get("field0104"));//银行支付合计
        main.put("textField_lm5okzry",businessDatamain.get("field0108"));//公司编码
        main.put("numberField_lm5okzs0",businessDatamain.get("field0110"));//费用预算年度
        main.put("textField_lm5okzs2",businessDatamain.get("field0114"));//付款金额合计大写
        main.put("textField_lm5okzs4",businessDatamain.get("field0115"));//报销信息合计大写
        main.put("numberField_lm5okzs6",businessDatamain.get("field0116"));//报销金额合计小写
        main.put("numberField_lm5okzs8",businessDatamain.get("field0117"));//付款信息合计小写
        main.put("textField_lm5okzsa",businessDatamain.get("field0118"));//项目
        main.put("textField_lm5okzsc",businessDatamain.get("field0120"));//项目编码
        main.put("textField_lm5okzse",businessDatamain.get("field0158"));//招待级别
        main.put("textField_lm5okzsg",businessDatamain.get("field0142"));//借款合计大写
        main.put("numberField_lm5okzsi",businessDatamain.get("field0143"));//借款合计小写
        main.put("textField_lm5okzsk",businessDatamain.get("field0149"));//借款合计大写1
        main.put("numberField_lm5okzsm",businessDatamain.get("field0150"));//借款合计小写1
        //报销信息(明细表1)
        Object formson_0295obj = businessData.get("formson_0295");
        JSONArray formson_0295Arr = JSON.parseArray(JSON.toJSONString(formson_0295obj));
        //formson_0295



        JSONArray tableField_lm5okzsnArr = new JSONArray();
        for(Object obj : formson_0295Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5okzsn = new JSONObject();
            tableField_lm5okzsn.put("textField_lm5okzsp",body.getString("field0094"));//费用类型
            tableField_lm5okzsn.put("numberField_lm5okzsr",body.getString("field0096"));//报销金额
            tableField_lm5okzsn.put("numberField_lm5okzst",body.getString("field0097"));//不含税金额
            tableField_lm5okzsn.put("textField_lm5okzsv",body.getString("field0030"));//费用归属部门
            tableField_lm5okzsn.put("numberField_lm5okzsx",body.getString("field0076"));//预算金额
            tableField_lm5okzsn.put("textField_lm5okzsz",body.getString("field0079"));//预算信息备注
            tableField_lm5okzsn.put("numberField_lm5okzt1",body.getString("field0107"));//剩余预算金额
            tableField_lm5okzsn.put("textField_lm5okzt3",body.getString("field0109"));//费用类别ID
            tableField_lm5okzsn.put("textField_lm5okzt5",body.getString("field0111"));//年度费用预算ID
            tableField_lm5okzsn.put("attachmentField_lm5okzt7",body.getString("field0119"));//发票上传
            tableField_lm5okzsn.put("textField_lm5okzt9",body.getString("field0122"));//发票号码
            tableField_lm5okzsn.put("textField_lm5okztb",body.getString("field0123"));//票据编码
            tableField_lm5okzsn.put("textField_lm5okztd",body.getString("field0124"));//费用名称
            tableField_lm5okzsn.put("numberField_lm5okztf",body.getString("field0126"));//税率
            tableField_lm5okzsn.put("numberField_lm5okzth",body.getString("field0127"));//税额
            tableField_lm5okzsn.put("textField_lm5okztj",body.getString("field0129"));//乘车人
            tableField_lm5okzsn.put("dateField_lm5okztl",DateUtil.dateStrToLong(String.valueOf(body.get("field0130"))));//日期
            tableField_lm5okzsn.put("dateField_lm5okztn",DateUtil.dateStrToLong(String.valueOf(body.get("field0131"))));//出发时间
            tableField_lm5okzsn.put("dateField_lm5okztp",DateUtil.dateStrToLong(String.valueOf(body.get("field0132"))));//到达时间
            tableField_lm5okzsn.put("numberField_lm5okztr",body.getString("field0133"));//发票金额
            tableField_lm5okzsn.put("textField_lm5okztt",body.getString("field0134"));//报销信息序号
            tableField_lm5okzsnArr.add(tableField_lm5okzsn);
            main.put("tableField_lm5okzsn",tableField_lm5okzsnArr);
        }


        //汇款信息明细表(明细表2)
        Object formson_0297obj = businessData.get("formson_0297");
        JSONArray formson_0297Arr = JSON.parseArray(JSON.toJSONString(formson_0297obj));
        //formson_0297

        JSONArray tableField_lm5qyiz4Arr = new JSONArray();
        for(Object obj : formson_0297Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5qyiz4 = new JSONObject();
            tableField_lm5qyiz4.put("textField_lm5okztv",body.getString("field0060"));//汇款信息序号
            tableField_lm5qyiz4.put("textField_lm5okztx",body.getString("field0069"));//付款方式
            tableField_lm5qyiz4.put("numberField_lm5okztz",body.getString("field0100"));//付款金额
            tableField_lm5qyiz4.put("textField_lm5okzu1",body.getString("field0098"));//开户行
            tableField_lm5qyiz4.put("textField_lm5okzu3",body.getString("field0073"));//开户行账号
            tableField_lm5qyiz4.put("textField_lm5okzu5",body.getString("field0070"));//银行支付
            tableField_lm5qyiz4.put("textField_lm5okzu7",body.getString("field0135"));//收款人开户名称
            tableField_lm5qyiz4.put("textField_lm5okzu9",body.getString("field0136"));//收款人账号
            tableField_lm5qyiz4Arr.add(tableField_lm5qyiz4);
            main.put("tableField_lm5qyiz4",tableField_lm5qyiz4Arr);
        }


        data.put("formDataJson",main.toString());
        data.put("userId",businessDatamain.get("field0157"));
        data.put("appType","APP_LLACU34DHTK2F07IEYVB");
        data.put("systemToken","IT5662C1PXUCS1NV6E40B61DNPLQ2PL30AQKLVA");
        data.put("formUuid","FORM-5Q966D91ORYDL2GYBAE4F77GWL922H2SKO5MLR");
        return data;
    }

    /**
     * 差旅费报销单
     * @param businessData
     * @param formApp
     * @return
     */
    private JSONObject boundDataTravelExpense(Map<String, Object> businessData, String formApp) {
        JSONObject data = new JSONObject();
        //todo 所有日期传递时间戳
        Object mainObj = businessData.get("formmain_0307");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        //组装主表数据
        JSONObject main = new JSONObject();
        main.put("textField_lm5ng0oz",businessDatamain.get("field0094"));//单据编号
        JSONArray field0279Arr = new JSONArray();
        String field0279 = businessDatamain.get("field0279").toString();
        field0279Arr.add(field0279);
        main.put("employeeField_lm5ng0p3",field0279Arr);//申请人

        main.put("dateField_lm5ng0p5",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0125"))));//申请日期
        JSONArray field0307Arr = new JSONArray();
        String field0307 = businessDatamain.get("field0307").toString();
        field0307Arr.add(field0307);

        main.put("departmentSelectField_lm5ng0p7",field0307Arr);//申请人部门
        main.put("textField_lm5ng0p9",businessDatamain.get("field0187"));//电话
        main.put("textField_lm5ng0pb",businessDatamain.get("field0221"));//关联出差申请
        main.put("textField_lm5ng0pd",businessDatamain.get("field0188"));//入账公司
        main.put("textField_lm5ng0pf",businessDatamain.get("field0189"));//出差国别
        main.put("dateField_lm5ng0ph",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0193"))));//出差开始时间
//        main.put("cascadeDateField_lm5ng0pl",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0194"))));//出差结束时间
        main.put("numberField_lm5ng0pn",businessDatamain.get("field0195"));//出差天数
        main.put("textField_lm5ng0pp",businessDatamain.get("field0199"));//出差说明
        main.put("textField_lm5ng0pr",businessDatamain.get("field0236"));//出差申请单号
        main.put("textField_lm5ng0pt",businessDatamain.get("field0234"));//商旅单号
        main.put("textField_lm5ng0pv",businessDatamain.get("field0155"));//费用预算ID
        main.put("textField_lm5ng0px",businessDatamain.get("field0280"));//1.4出差类型
        main.put("textField_lm5ng0pz",businessDatamain.get("field0056"));//1.5出差审批
        main.put("textField_lm5ng0q1",businessDatamain.get("field0137"));//2.7费用类别
        main.put("textField_lm5ng0q3",businessDatamain.get("field0149"));//2.8预算年度
        main.put("textField_lm5ng0q5",businessDatamain.get("field0159"));//2.10预算部门
        main.put("numberField_lm5ng0q9",businessDatamain.get("field0181"));//3.1费用金额合计
        main.put("numberField_lm5ng0qb",businessDatamain.get("field0177"));//3.2未税金额合计
        main.put("numberField_lm5ng0qd",businessDatamain.get("field0178"));//3.3税额合计
        main.put("numberField_lm5ng0qf",businessDatamain.get("field0075"));//3.4实际出差天数
        main.put("numberField_lm5ng0qh",businessDatamain.get("field0074"));//3.5出差补助合计
        main.put("numberField_lm5ng0qj",businessDatamain.get("field0145"));//3.6实际住宿天数
        main.put("numberField_lm5ng0ql",businessDatamain.get("field0072"));//3.7住宿费合计
        main.put("textField_lm5ng0qn",businessDatamain.get("field0174"));//3.8备注
        main.put("numberField_lm5ng0qp",businessDatamain.get("field0076"));//3.9报销金额
        main.put("numberField_lm5ng0qr",businessDatamain.get("field0078"));//3.10借支金额
        main.put("numberField_lm5ng0qt",businessDatamain.get("field0080"));//3.11冲抵金额
        main.put("numberField_lm5ng0qv",businessDatamain.get("field0079"));//3.12归还金额
        main.put("numberField_lm5ng0qx",businessDatamain.get("field0081"));//3.13本次支付金额
        main.put("textField_lm5ng0qz",businessDatamain.get("field0082"));//3.14本次支付金额大写
        main.put("numberField_lm5ng0r1",businessDatamain.get("field0117"));//3.15单据总数
        main.put("textField_lm5ng0r3",businessDatamain.get("field0281"));//3.16支付方式
        main.put("dateField_lm5ng0r5",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0118"))));//3.17支付日期
        main.put("textField_lm5ng0r7",businessDatamain.get("field0131"));//3.18银行账户
        main.put("textField_lm5ng0r9",businessDatamain.get("field0132"));//3.19开户银行
        main.put("textField_lm5ng0rb",businessDatamain.get("field0133"));//3.20银行账号
        main.put("textField_lm5ng0rd",businessDatamain.get("field0084"));//4.1审批领导
        main.put("textField_lm5ng0rf",businessDatamain.get("field0085"));//4.2会计
        main.put("textField_lm5ng0rh",businessDatamain.get("field0086"));//4.3出纳
        main.put("textField_lm5ng0rj",businessDatamain.get("field0119"));//0.2借款编号
        main.put("numberField_lm5ng0rl",businessDatamain.get("field0123"));//0.3欠款金额
        main.put("textField_lm5ng0rn",businessDatamain.get("field0282"));//0.4报销单类型
        main.put("textField_lm5ng0rp",businessDatamain.get("field0283"));//0.5支出类型
        main.put("textField_lm5ng0rr",businessDatamain.get("field0139"));//0.6职务级别
        main.put("textField_lm5ng0rt",businessDatamain.get("field0140"));//0.7补贴标准
        main.put("textField_lm5ng0rv",businessDatamain.get("field0141"));//0.8住宿标准
        main.put("textField_lm5ng0rx",businessDatamain.get("field0284"));//0.9管控类型
        main.put("textField_lm5ng0rz",businessDatamain.get("field0285"));//0.10预算状态
        main.put("textField_lm5ng0s1",businessDatamain.get("field0186"));//0.11凭证编号
        main.put("textField_lm5ng0s3",businessDatamain.get("field0120"));//强控填写提示
        main.put("textField_lm5ng0s5",businessDatamain.get("field0168"));//弱控填写提示
        main.put("textField_lm5ng0s7",businessDatamain.get("field0220"));//公司编码
        main.put("textField_lm5ng0s9",businessDatamain.get("field0243"));//报销金额合计大写
        main.put("numberField_lm5ng0sd",businessDatamain.get("field0244"));//报销金额合计小写
        main.put("textField_lm5ng0sf",businessDatamain.get("field0245"));//付款金额合计大写
        main.put("numberField_lm5ng0sh",businessDatamain.get("field0246"));//付款金额合计小写
        main.put("textField_lm5ng0sj",businessDatamain.get("field0247"));//筛选入账公司
        main.put("textField_lm5ng0sl",businessDatamain.get("field0248"));//项目
        main.put("textField_lm5ng0sn",businessDatamain.get("field0249"));//项目编码
        main.put("textField_lm5ng0sp",businessDatamain.get("field0264"));//差旅标准


        //报销明细(明细表1)
        Object formson_0308obj = businessData.get("formson_0308");
        JSONArray formson_0308Arr = JSON.parseArray(JSON.toJSONString(formson_0308obj));
        //formson_0308


        JSONArray tableField_lm5ng0sqbArr = new JSONArray();
        for(Object obj :formson_0308Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5ng0sq = new JSONObject();
            tableField_lm5ng0sq.put("textField_lm5ng0ss",body.getString("field0027"));//L1.0序号
            tableField_lm5ng0sq.put("dateField_lm5ng0sw",DateUtil.dateStrToLong(String.valueOf(body.get("field0061"))));//L1.1出发时间
            tableField_lm5ng0sq.put("dateField_lm5ng0sy",DateUtil.dateStrToLong(String.valueOf(body.get("field0066"))));//L1.2到达时间
            tableField_lm5ng0sq.put("textField_lm5ng0t0",body.getString("field0062"));//L1.3出发地
            tableField_lm5ng0sq.put("textField_lm5ng0t2",body.getString("field0063"));//L1.4目的地
            tableField_lm5ng0sq.put("numberField_lm5ng0t4",body.getString("field0064"));//L1.5单据数
            tableField_lm5ng0sq.put("textField_lm5ng0t6",body.getString("field0179"));//L1.6费用项目
            tableField_lm5ng0sq.put("textField_lm5ng0t8",body.getString("field0180"));//L1.7费用金额
            tableField_lm5ng0sq.put("numberField_lm5ng0ta",body.getString("field0182"));//L1.8税率
            tableField_lm5ng0sq.put("numberField_lm5ng0tc",body.getString("field0183"));//L1.9未税金额
            tableField_lm5ng0sq.put("numberField_lm5ng0te",body.getString("field0184"));//L1.10税额
            tableField_lm5ng0sq.put("attachmentField_lm5ng0tg",body.getString("field0161"));//L1.11附件
            tableField_lm5ng0sq.put("dateField_lm5ng0ti",DateUtil.dateStrToLong(String.valueOf(body.get("field0126"))));//L1.11交通日期
            tableField_lm5ng0sq.put("textField_lm5ng0tk",body.getString("field0127"));//L1.12事由
            tableField_lm5ng0sq.put("textField_lm5ng0tm",body.getString("field0128"));//L1.13交通类别
            tableField_lm5ng0sqbArr.add(tableField_lm5ng0sq);
            main.put("tableField_lm5ng0sq",tableField_lm5ng0sqbArr);
        }


        //报销信息明细表(明细表2)
        Object formson_0309obj = businessData.get("formson_0309");
        JSONArray formson_0309Arr = JSON.parseArray(JSON.toJSONString(formson_0309obj));
        //formson_0309



        JSONArray tableField_lm5ng0tnArr = new JSONArray();
        for(Object obj : formson_0309Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5ng0tn = new JSONObject();
            tableField_lm5ng0tn.put("textField_lm5ng0tp",body.getString("field0227"));//费用类别
            tableField_lm5ng0tn.put("numberField_lm5ng0tr",body.getString("field0222"));//预估金额
            tableField_lm5ng0tn.put("numberField_lm5ng0tt",body.getString("field0228"));//年度当前可用余额
            tableField_lm5ng0tn.put("numberField_lm5ng0tv",body.getString("field0203"));//报销金额
            tableField_lm5ng0tn.put("numberField_lm5ng0tx",body.getString("field0204"));//不含税金额
            tableField_lm5ng0tn.put("textField_lm5ng0tz",body.getString("field0223"));//费用归属部门
            tableField_lm5ng0tn.put("textField_lm5ng0u1",body.getString("field0226"));//成本中心
            tableField_lm5ng0tn.put("textField_lm5ng0u3",body.getString("field0229"));//年度费用预算ID
            tableField_lm5ng0tn.put("textField_lm5ng0u5",body.getString("field0230"));//预算状态
            tableField_lm5ng0tn.put("textField_lm5ng0u7",body.getString("field0231"));//费用类别ID
            tableField_lm5ng0tn.put("textField_lm5ng0u9",body.getString("field0201"));//管控类型
            tableField_lm5ng0tn.put("attachmentField_lm5ng0ub",null);//发票上传
            tableField_lm5ng0tn.put("textField_lm5ng0ud",body.getString("field0253"));//票据编码
            tableField_lm5ng0tn.put("textField_lm5ng0uf",body.getString("field0254"));//费用名称
            tableField_lm5ng0tn.put("textField_lm5ng0uh",body.getString("field0255"));//发票号码
            tableField_lm5ng0tn.put("numberField_lm5ng0uj",body.getString("field0256"));//税额
            tableField_lm5ng0tn.put("numberField_lm5ng0ul",body.getString("field0257"));//税率
            tableField_lm5ng0tn.put("textField_lm5ng0un",body.getString("field0258"));//乘车人
            tableField_lm5ng0tn.put("dateField_lm5ng0up",DateUtil.dateStrToLong(String.valueOf(body.get("field0259"))));//日期
            tableField_lm5ng0tn.put("dateField_lm5ng0ur",DateUtil.dateStrToLong(String.valueOf(body.get("field0260"))));//出发时间
            tableField_lm5ng0tn.put("dateField_lm5ng0ut",DateUtil.dateStrToLong(String.valueOf(body.get("field0261"))));//到达时间
            tableField_lm5ng0tn.put("numberField_lm5ng0uv",body.getString("field0262"));//发票金额
            tableField_lm5ng0tn.put("textField_lm5ng0ux",body.getString("field0263"));//报销信息序号
            tableField_lm5ng0tnArr.add(tableField_lm5ng0tn);
            main.put("tableField_lm5ng0tn",tableField_lm5ng0tnArr);
        }


        //汇款信息明细表(明细表3)
        Object formson_0311obj = businessData.get("formson_0311");
        JSONArray formson_0311Arr = JSON.parseArray(JSON.toJSONString(formson_0311obj));
        //formson_0311



        JSONArray tableField_lm5ng0uybArr = new JSONArray();
        for(Object obj : formson_0311Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5ng0uy = new JSONObject();
            tableField_lm5ng0uy.put("textField_lm5ng0v0",body.getString("field0213"));//汇款信息序号
            tableField_lm5ng0uy.put("textField_lm5ng0v2",body.getString("field0214"));//付款方式
            tableField_lm5ng0uy.put("numberField_lm5ng0v4",body.getString("field0215"));//付款金额
            tableField_lm5ng0uy.put("textField_lm5ng0v6",body.getString("field0265"));//付款方开户名称
            tableField_lm5ng0uy.put("textField_lm5ng0v8",body.getString("field0266"));//付款方账号
            tableField_lm5ng0uy.put("textField_lm5ng0va",body.getString("field0216"));//收款人开户名称
            tableField_lm5ng0uy.put("textField_lm5ng0vc",body.getString("field0218"));//收款人账号
            tableField_lm5ng0uybArr.add(tableField_lm5ng0uy);
            main.put("tableField_lm5ng0uy", tableField_lm5ng0uybArr);
        }

        data.put("formDataJson",main.toString());
        data.put("userId",businessDatamain.get("field0279"));
        data.put("appType","APP_LLACU34DHTK2F07IEYVB");
        data.put("systemToken","IT5662C1PXUCS1NV6E40B61DNPLQ2PL30AQKLVA");
        data.put("formUuid","FORM-4V966QC1U7ZDP7WVBLX9EDIYNM7U2P1SFN5ML1");
        return data;
    }

    /**
     * 开票申请
     * @param businessData
     * @param formApp
     * @return
     */
    private JSONObject boundDataInv(Map<String, Object> businessData, String formApp)throws Exception {
        JSONObject data = new JSONObject();
        //todo 所有日期传递时间戳
        //组装主表数据
        Object mainObj = businessData.get("formmain_0331");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        JSONObject main = new JSONObject();
        main.put("textField_lm4pqj9b",businessDatamain.get("field0117"));//单据编号
        main.put("textField_lm4pqj9d",businessDatamain.get("field0113"));//关联合同档案

        JSONArray field0115Arr = new JSONArray();
        String field0115 = businessDatamain.get("field0136").toString();//这个存放的直接定钉钉主键，固直接用field0136
        field0115Arr.add(field0115);
        main.put("employeeField_lm4pqj9f",field0115Arr);//申请人
        main.put("dateField_lm4pqj9g",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0114"))));//申请日期

        JSONArray field0144Arr = new JSONArray();
        String field0144 = businessDatamain.get("field0144").toString();
        field0144Arr.add(field0144);

        main.put("departmentSelectField_lm4pqj9h",field0144Arr);//申请人部门
        main.put("textField_lm4pqj9j",businessDatamain.get("field0112"));//申请人电话
        main.put("textField_lm4pqj9l",businessDatamain.get("field0108"));//开票公司
        main.put("textField_lm4pqj9n",businessDatamain.get("field0137"));//税控发票类型
        main.put("textField_lm4pqj9p",businessDatamain.get("field0111"));//收件人邮箱
        main.put("textField_lm4pqj9r",businessDatamain.get("field0106"));//客户名称
        main.put("textField_lm4pqj9t",businessDatamain.get("field0105"));//税号
        main.put("textField_lm4pqj9v",businessDatamain.get("field0103"));//开户行
        main.put("textField_lmefk8vz",businessDatamain.get("field0102"));//账号
        main.put("textField_lm4pqj9x",businessDatamain.get("field0100"));//地址
        main.put("textField_lm4pqj9z",businessDatamain.get("field0101"));//电话
        main.put("textField_lm4pqja1",businessDatamain.get("field0098"));//发票代码
        main.put("textField_lm4pqja3",businessDatamain.get("field0141"));//是否含税录入
        main.put("numberField_lm4pqja5",businessDatamain.get("field0094"));//合计不含税金额
        main.put("numberField_lm4pqja7",businessDatamain.get("field0095"));//合计含税金额
        main.put("numberField_lm4pqja9",businessDatamain.get("field0096"));//价税合计
        main.put("textareaField_lm4pqjad",businessDatamain.get("field0092"));//发票备注
        main.put("textField_lm4pqjaf",businessDatamain.get("field0142"));//是否邮寄
        main.put("textareaField_lm4pqjah",businessDatamain.get("field0090"));//开票说明
        main.put("numberField_lm4pqjaj",businessDatamain.get("field0121"));//本次开票数量合计
        String field0123 = String.valueOf(businessDatamain.get("field0123"));
        main.put("dateField_lm4pqjal",DateUtil.dateStrToLong(field0123));//合同签订日期
        main.put("textField_lm4pqjan",businessDatamain.get("field0138"));//业务板块一级
        main.put("textField_lm4pqjap",businessDatamain.get("field0139"));//业务板块二级
        main.put("textField_lm4pqjar",businessDatamain.get("field0126"));//邮寄地址
        main.put("textField_lm4pqjat",businessDatamain.get("field0132"));//借款合计大写
        main.put("numberField_lm4pqjav",businessDatamain.get("field0133"));//借款合计小写
        //销售发票明细表
        Object formson_0332obj = businessData.get("formson_0332");
        JSONArray formson_0332Arr = JSON.parseArray(JSON.toJSONString(formson_0332obj));


        JSONArray tableField_lm4pqjawtArr = new JSONArray();
        for(Object obj :formson_0332Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm4pqjaw = new JSONObject();
            tableField_lm4pqjaw.put("textField_lm4pqjay",body.getString("field0079"));//序号
            tableField_lm4pqjaw.put("textField_lm4pqjb0",body.getString("field0080"));//合同标的物名称
            tableField_lm4pqjaw.put("textField_lm4pqjb2",body.getString("field0081"));//标的物编码
            tableField_lm4pqjaw.put("textField_lm4pqjb4",body.getString("field0083"));//规格型号
            tableField_lm4pqjaw.put("numberField_lm4pqjb6",body.getString("field0084"));//数量
            tableField_lm4pqjaw.put("numberField_lm4pqjb8",body.getString("field0122"));//本次开票数量
            tableField_lm4pqjaw.put("numberField_lm4pqjba",body.getString("field0085"));//单价
            tableField_lm4pqjaw.put("numberField_lm4pqjbc",body.getString("field0086"));//不含税金额
            tableField_lm4pqjaw.put("numberField_lm4pqjbe",body.getString("field0087"));//含税金额
            tableField_lm4pqjaw.put("numberField_lm4pqjbg",body.getString("field0118"));//税率
            tableField_lm4pqjaw.put("textField_lm4pqjbi",body.getString("field0119"));//税务编码
            tableField_lm4pqjawtArr.add(tableField_lm4pqjaw);
            main.put("tableField_lm4pqjaw",tableField_lm4pqjawtArr);
        }

        Object formson_0365obj = businessData.get("formson_0365");
        JSONArray formson_0365Arr = JSON.parseArray(JSON.toJSONString(formson_0365obj));
        //formson_0365
        JSONArray tableField_lm4pqjbjArr = new JSONArray();
        for(Object obj :formson_0365Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm4pqjbj = new JSONObject();
            tableField_lm4pqjbj.put("textField_lm4pqjbl",body.getString("field0127"));//序号1
            tableField_lm4pqjbj.put("textField_lm4pqjbn",body.getString("field0128"));//借款日期
            tableField_lm4pqjbj.put("numberField_lm4pqjbp",body.getString("field0129"));//借款金额
            tableField_lm4pqjbj.put("textField_lm4pqjbr",body.getString("field0130"));//借款单
            tableField_lm4pqjbj.put("textareaField_lm4pqjbt",body.getString("field0131"));//用途
            tableField_lm4pqjbjArr.add(tableField_lm4pqjbj);
            main.put("tableField_lm4pqjbj",tableField_lm4pqjbjArr);
        }


        data.put("formDataJson",main.toString());
        data.put("userId",businessDatamain.get("field0136"));
        data.put("appType","APP_LLACU34DHTK2F07IEYVB");
        data.put("systemToken","IT5662C1PXUCS1NV6E40B61DNPLQ2PL30AQKLVA");
        data.put("formUuid","FORM-ZK866D911PWD088REOMK541LMX6E30J5QP4MLI");
        return data;
    }

    /**
     * 对公付款单
     * @param businessData
     * @param formApp
     * @return
     */
    private JSONObject boundDataPay(Map<String, Object> businessData, String formApp)throws Exception {
        JSONObject data = new JSONObject();
        //todo 所有日期传递时间戳
        //组装主表数据
        Object mainObj = businessData.get("formmain_0327");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
        JSONObject main = new JSONObject();
        main.put("textField_lm4os547",businessDatamain.get("field0146"));//单据编号
        main.put("textField_lm4os549",businessDatamain.get("field0034"));//关联合同编号
        JSONArray field0236Arr = new JSONArray();
        String field0236 = businessDatamain.get("field0236").toString();
        field0236Arr.add(field0236);
        //申请人需要单独处理 传递钉钉ID，格式为["user01","user02"] 存放钉钉主键
        main.put("employeeField_lm4os54b",field0236Arr);//申请人
//        String field0041 = businessDatamain.get("field0041").toString();
//        Long field0041long = null ;
//         if(StrUtil.isNotEmpty(field0041)){
//            field0041long = DateUtil.stringToDate(field0041,"yyyy-MM-dd HH:mm:ss").getTime();
//        }
        main.put("dateField_lm4os54j",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0041"))));//申请日期
        main.put("textField_lm4os54l",businessDatamain.get("field0110"));//申请人电话
        JSONArray field0253Arr = new JSONArray();
        String field0253 = businessDatamain.get("field0253").toString();
        field0253Arr.add(field0253);
        main.put("departmentSelectField_lm4os54n",field0253Arr);//申请人部门

        main.put("textField_lm4os54u",businessDatamain.get("field0116"));//入账公司
        main.put("textField_lm4os54w",businessDatamain.get("field0239"));//付款类型一级
        main.put("textField_lm4os54y",businessDatamain.get("field0240"));//付款类型二级
        main.put("textField_lm4os550",businessDatamain.get("field0119"));//供应商
        main.put("textField_lm4os552",businessDatamain.get("field0121"));//本次付款金额
        main.put("textField_lm4os554",businessDatamain.get("field0122"));//本次付款比例
        main.put("textField_lm4os556",businessDatamain.get("field0242"));//是否固定金额
        main.put("numberField_lm4os55a",businessDatamain.get("field0123"));//合同总金额
        main.put("textareaField_lm4os55c",businessDatamain.get("field0124"));//报账说明
        main.put("attachmentField_lm4os55e","");//附件
        main.put("textField_lm4os55g",businessDatamain.get("field0149"));//公司编码
        main.put("textField_lm4os55i",businessDatamain.get("field0151"));//供应商编码
        main.put("textField_lm4os55k",businessDatamain.get("field0152"));//户名
        main.put("textField_lm4os55s",businessDatamain.get("field0153"));//开户行编码
        main.put("textField_lm4os55u",businessDatamain.get("field0154"));//开户行名称
        main.put("textField_lm4os55w",businessDatamain.get("field0155"));//账号
//        String field0158 = businessData.get("field0158").toString();
//        Long field0158long = null ;
//        if(StrUtil.isNotEmpty(field0158)){
//            field0158long = DateUtil.stringToDate(field0158,"yyyy-MM-dd HH:mm:ss").getTime();
//        }
        main.put("dateField_lm4os55y",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0158"))));//合同签订日期
        main.put("textField_lm4os560",businessDatamain.get("field0238"));//是否有合同
        main.put("textField_lm4os562",businessDatamain.get("field0166"));//合同已付金额
        main.put("numberField_lm4os564",businessDatamain.get("field0167"));//发票已收金额
        main.put("numberField_lm4os566",businessDatamain.get("field0168"));//审批中付款金额
        main.put("numberField_lm4os568",businessDatamain.get("field0169"));//审批中已收发票金额
        main.put("textField_lm4os56a",businessDatamain.get("field0184"));//发票金额合计大写
        main.put("numberField_lm4os56c",businessDatamain.get("field0185"));//发票金额合计小写
        main.put("textField_lm4os56e",businessDatamain.get("field0186"));//项目编码
        main.put("textField_lm4os56g",businessDatamain.get("field0243"));//业务场景
        main.put("textField_lm4os56i",businessDatamain.get("field0244"));//是否多项目
        main.put("attachmentField_lm4os56k",null);//合同附件
        main.put("textField_lm4os56m",businessDatamain.get("field0201"));//借款合计大写
        main.put("numberField_lm4os56o",businessDatamain.get("field0202"));//借款合计小写
        main.put("textField_lm4os56q",businessDatamain.get("field0208"));//借款合计大写1
        main.put("numberField_lm4os56s",businessDatamain.get("field0209"));//借款合计小写1
        //汇款信息明细表(明细表1)
        Object formson_0329obj = businessData.get("formson_0329");
        JSONArray formson_0329Arr = JSON.parseArray(JSON.toJSONString(formson_0329obj));
        //formson_0329
        JSONArray tableField_lm4os56tArr = new JSONArray();
        //循环拼接汇款明细数据
        for(Object obj :formson_0329Arr){
            JSONObject formson_0329 = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm4os56t = new JSONObject();
            tableField_lm4os56t.put("textField_lm4os56v",formson_0329.get("field0133"));//汇款信息序号
            tableField_lm4os56t.put("textField_lm4os56x",formson_0329.get("field0134"));//付款方式
            tableField_lm4os56t.put("numberField_lm4os56z",formson_0329.get("field0135"));//付款金额
            tableField_lm4os56t.put("textField_lm4os571",formson_0329.get("field0136"));//收款单位
            tableField_lm4os56t.put("textField_lm4os573",formson_0329.get("field0137"));//付款账号
            tableField_lm4os56tArr.add(tableField_lm4os56t);
        }
        main.put("tableField_lm4os56t",tableField_lm4os56tArr);
        //扣款信息明细表(明细表2)
        Object formson_0330obj = businessData.get("formson_0330");
        JSONArray formson_0330Arr = JSON.parseArray(JSON.toJSONString(formson_0330obj));
        //formson_0330
        JSONArray tableField_lm4os574Arr = new JSONArray();
        for(Object obj :formson_0330Arr){
            JSONObject formson_0330 = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm4os574 = new JSONObject();
            tableField_lm4os574.put("textField_lm4os576",formson_0330.get("field0140"));//一级支出类别
            tableField_lm4os574.put("textField_lm4os578",formson_0330.get("field0147"));//隐藏-扣款信息款项类别二级
            tableField_lm4os574.put("textField_lm4os57a",formson_0330.get("field0142"));//项目号
            tableField_lm4os574.put("numberField_lm4os57e",formson_0330.get("field0143"));//不含税金额
            tableField_lm4os574.put("numberField_lm4os57g",formson_0330.get("field0144"));//含税金额
            tableField_lm4os574.put("numberField_lm4os57i",formson_0330.get("field0145"));//价税合计
            tableField_lm4os574.put("textField_lm4os57k",formson_0330.get("field0163"));//扣款信息序号
            tableField_lm4os574Arr.add(tableField_lm4os574);
            main.put("tableField_lm4os574",tableField_lm4os574Arr);
        }

        //发票明细表(明细表3)
        Object formson_0348obj = businessData.get("formson_0348");
        JSONArray formson_0348Arr = JSON.parseArray(JSON.toJSONString(formson_0348obj));
        //formson_0348
        JSONArray tableField_lm4os57lArr = new JSONArray();
        for(Object obj :formson_0348Arr){
            JSONObject formson_0348 = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm4os57l = new JSONObject();
            tableField_lm4os57l.put("textField_lm4os57n",formson_0348.get("field0170"));//发票信息序号
            tableField_lm4os57l.put("textField_lm4os57p",formson_0348.get("field0171"));//发票号码
            tableField_lm4os57l.put("textField_lm4os57r",formson_0348.get("field0172"));//发票代码
            tableField_lm4os57l.put("numberField_lm4os57t",formson_0348.get("field0173"));//发票金额
            tableField_lm4os57l.put("numberField_lm4os57v",formson_0348.get("field0174"));//发票税额
            tableField_lm4os57l.put("attachmentField_lm4os57x","");//上传发票
            tableField_lm4os57l.put("textField_lm4os57z",formson_0348.get("field0179"));//售方名称
            tableField_lm4os57l.put("textField_lm4os581",formson_0348.get("field0180"));//购方名称
            tableField_lm4os57l.put("textField_lm4os583",formson_0348.get("field0181"));//购方税号
            tableField_lm4os57l.put("textField_lm4os585",formson_0348.get("field0182"));//发票入账公司
            tableField_lm4os57l.put("textField_lm4os587",formson_0348.get("field0183"));//税号
            tableField_lm4os57l.put("textField_lm4os58b",formson_0348.get("field0188"));//发票类型
            tableField_lm4os57lArr.add(tableField_lm4os57l);
            main.put("tableField_lm4os57l",tableField_lm4os57lArr);
        }

        //项目明细表(明细表4)
        Object formson_0354obj = businessData.get("formson_0354");
        JSONArray formson_0354Arr = JSON.parseArray(JSON.toJSONString(formson_0354obj));
        //formson_0354

        JSONArray tableField_lm4os58cArr = new JSONArray();
        for(Object obj :formson_0354Arr){
            JSONObject formson_0354 = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm4os58c = new JSONObject();
            tableField_lm4os58c.put("textField_lm4os57n",formson_0354.getString("field0192"));//项目信息序号
            tableField_lm4os58c.put("textField_lm4os57p",formson_0354.getString("field0191"));//项目明细表项目
            tableField_lm4os58c.put("textField_lm4os57r",formson_0354.getString("field0193"));//发票拆分金额
            tableField_lm4os58cArr.add(tableField_lm4os58c);
            main.put("tableField_lm4os58c",tableField_lm4os58cArr);
        }
        data.put("formDataJson",main.toString());
        data.put("userId",businessDatamain.get("field0236"));
//        data.put("userId","182411126520375411");
        data.put("appType","APP_LLACU34DHTK2F07IEYVB");
        data.put("systemToken","IT5662C1PXUCS1NV6E40B61DNPLQ2PL30AQKLVA");
        data.put("formUuid","FORM-JD8668C1KMYDNNEW6OPQE8M8K2YU2SJURO4ML0");
//        return null;
        return data;
    }

    /**
     * 出差申请单
     * @param businessData
     * @param formApp
     * @return
     */
    private JSONObject boundDataBusinessTravel(Map<String, Object> businessData, String formApp) {
        JSONObject data = new JSONObject();
        //todo 所有日期传递时间戳
        //组装主表数据
        Object mainObj = businessData.get("formmain_0302");
        JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));

        JSONObject main = new JSONObject();
        main.put("textField_lm5n374e",businessDatamain.get("field0001"));//单据编号
        JSONArray field0085Arr = new JSONArray();
        String field0085 = businessDatamain.get("field0085").toString();
        field0085Arr.add(field0085);
        //申请人需要单独处理 传递钉钉ID，格式为["user01","user02"] 存放钉钉主键
        main.put("employeeField_lm5n374g",field0085Arr);//申请人
        main.put("dateField_lm5n374i",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0027"))));//申请日期

        JSONArray field0088Arr = new JSONArray();
        String field0088 = businessDatamain.get("field0088").toString();
        field0088Arr.add(field0088);

        main.put("departmentSelectField_lm5n374j",field0088Arr);//申请人部门
        main.put("textField_lm5n374k",businessDatamain.get("field0030"));//电话
        main.put("textField_lm5n374m",businessDatamain.get("field0086"));//入账公司
        main.put("textField_lm5n374o",businessDatamain.get("field0032"));//出差国别
        main.put("dateField_lm5n374q",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0036"))));//出差开始时间
        main.put("dateField_lm5n374s",DateUtil.dateStrToLong(String.valueOf(businessDatamain.get("field0038"))));//出差结束时间
        main.put("numberField_lm5n374u",businessDatamain.get("field0039"));//出差天数
        main.put("textField_lm5n374w",businessDatamain.get("field0059"));//选择商旅账号
        main.put("textField_lm5n374y",businessDatamain.get("field0064"));//出差事由
        main.put("textField_lm5n3750",businessDatamain.get("field0065"));//公司编码
        main.put("textField_lm5n3752",businessDatamain.get("field0031"));//项目名称
        main.put("textField_lm5n3754",businessDatamain.get("field0006"));//出发地
        main.put("textField_lm5n3756",businessDatamain.get("field0007"));//目的地
        main.put("textField_lm5n3758",businessDatamain.get("field0079"));//项目
        main.put("textField_lm5n375a",businessDatamain.get("field0080"));//项目编码

        //行程信息(明细表1)
        Object formson_0303obj = businessData.get("formson_0303");
        JSONArray formson_0303Arr = JSON.parseArray(JSON.toJSONString(formson_0303obj));
        //formson_0303
        JSONArray tableField_lm5n375bArr = new JSONArray();
        for(Object obj : formson_0303Arr){
            JSONObject body  = JSON.parseObject(JSON.toJSONString(obj));
            JSONObject tableField_lm5n375b = new JSONObject();
            tableField_lm5n375b.put("textField_lm5n375d",body.getString("field0072"));//序号
            tableField_lm5n375b.put("textField_lm5n375f",body.getString("field0050"));//费用名称
            tableField_lm5n375b.put("textField_lm5n375h",body.getString("field0070"));//行程类别
            tableField_lm5n375b.put("textField_lm5n375j",body.getString("field0071"));//是否往返
            tableField_lm5n375b.put("employeeField_lm5n375l",body.getString("field0073"));//出行人员
            tableField_lm5n375b.put("dateField_lm5n375n",DateUtil.dateStrToLong(String.valueOf(body.get("field0074"))));//开始时间
            tableField_lm5n375b.put("dateField_lm5n375p",DateUtil.dateStrToLong(String.valueOf(body.get("field0074"))));//结束时间
            tableField_lm5n375b.put("textField_lm5n375r",body.getString("field0076"));//出发城市
            tableField_lm5n375b.put("textField_lm5n375t",body.getString("field0077"));//到达城市
            tableField_lm5n375b.put("textField_lm5n375v",body.getString("field0041"));//费用归属部门
            tableField_lm5n375b.put("numberField_lm5n375x",body.getString("field0046"));//金额
            tableField_lm5n375b.put("textField_lm5n375z",body.getString("field0048"));//备注
            tableField_lm5n375b.put("textField_lm5n3761",body.getString("field0066"));//费用类别ID
            tableField_lm5n375b.put("textField_lm5n3763",body.getString("field0082"));//是否线下预定
            tableField_lm5n375bArr.add(tableField_lm5n375b);
            main.put("tableField_lm5n375b",tableField_lm5n375bArr);
        }



        data.put("formDataJson",main.toString());
        data.put("userId",businessDatamain.get("field0085"));
        data.put("appType","APP_LLACU34DHTK2F07IEYVB");
        data.put("systemToken","IT5662C1PXUCS1NV6E40B61DNPLQ2PL30AQKLVA");
        data.put("formUuid","FORM-JH9660C1NWYD9IFGCZAJT6P8F6TT25GY2N5ML3");
        return data;
    }

    @Override
    public JsonResultEntity thirdInterfaceInitBipSupplierToOa(JSONObject jsonObject) throws Exception {

        logger.info("执行同步供应商方法");

        String bipApiId = "a0a64273e60b4ccdb245683dfefdade5";
        JSONObject bipResult = iExcApiService.execute(bipApiId);
        logger.info("bip数据" + bipResult.toJSONString());
        //
        JSONArray attributes = bipResult.getJSONArray("attribute");

        ApplicationContextUtil.getBeanByClass(IExcApiService.class);
//        ApplicationContextUtil.getBeanByName("seeYonInterFace222");
//        ApplicationContextUtil.getBeanByClass(ISeeYonInterFace.class);
        JSONObject jsonObject1 = new JSONObject();
        jsonObject1.put("type", "archives");
        jsonObject1.put("templateCode", "formmain_0360");
        jsonObject1.put("attribute", attributes);
        JSONObject req = new JSONObject();
        req.put("jsonStr", jsonObject1.toJSONString());
        thirdInterfaceSend(req);

        return BaseResult.getSuccessMessageEntity("同步供应商成功");
    }

    /**
     * 通过关联关系获取附件主键
     * @param sub_reference
     * @return
     */
    @Override
    public  List<SeeyonEntity>  getFileUrl(String sub_reference) {
        SeeyonEntity seeyonEntity = new SeeyonEntity();
        if(StrUtil.isNotEmpty(sub_reference)){
            seeyonEntity.setSub_reference(sub_reference);
            return seeYonDao.selectFileUrl(seeyonEntity);
        }
        return null;
    }


    //通知单审批通过
    private String ddApproveFinish(Map<String, Object> businessData) {
        JSONObject finishData = new JSONObject();
        String to_time = null ;
        String from_time = null;
        if(null != businessData.get("field0036")){
            from_time =   DateUtil.dateToString(Long.valueOf(businessData.get("field0036").toString()),"YYYY-MM-dd");
        }
        if(null != businessData.get("field0038")){
            to_time =   DateUtil.dateToString(Long.valueOf(businessData.get("field0038").toString()),"YYYY-MM-dd");
        }
        finishData.put("userid",businessData.get("field0083"));
        finishData.put("biz_type","2");
        finishData.put("from_time",from_time);
        finishData.put("to_time",to_time);
        finishData.put("duration_unit","day");
        finishData.put("tag_name","出差");
        finishData.put("calculate_model","1");
        //出差单ID
        finishData.put("approve_id","approve_id");
        //出差单URL,和钉钉确认不处理
        finishData.put("jump_url","jump_url");
        JSONObject ddData = new JSONObject();
        ddData.put("code","0002");
        ddData.put("data",finishData.toJSONString());

        JSONObject jsonObject = new JSONObject();
        jsonObject.put("jsonStr",ddData.toJSONString());
        return iddInterfaceService.senddd(jsonObject);
    }

    @Override
    public JsonResultEntity thirdInterfacegetOADataByType(JSONObject requestData) {
        if (StrUtil.isBlank(LAST_SYNCHRONISED_TIME)) {
            LAST_SYNCHRONISED_TIME = cn.hutool.core.date.DateUtil.now();
        }
        //暂存时间
        String tempTime = LAST_SYNCHRONISED_TIME;
        //返回主表信息
        SeeyonEntity seeyon = new SeeyonEntity();
        seeyon.setTableName("formmain_0323");
        seeyon.setUpdateTime(tempTime);
        List<SeeyonEntity> seeyonEntityList = seeYonDao.selectOAListByTypeMain(seeyon);
        //如果返回数据不为空，则继续查询相关明细信息
        if (null != seeyonEntityList && seeyonEntityList.size() > 0) {
            // 设置上一次同步时间
            LAST_SYNCHRONISED_TIME = cn.hutool.core.date.DateUtil.now();
            for (SeeyonEntity s : seeyonEntityList) {
                //获取合同标的物明细(明细表1)
                List<SeeyonEntity> formson0324List = seeYonDao.selectOAListByTypeformson_0324(s);
                s.setFormson_0324(formson0324List);
                //相对方(明细表2)
                List<SeeyonEntity> formson0352List = seeYonDao.selectOAListByTypeformson_0352(s);
                s.setFormson_0352(formson0352List);
//                seeYonDao.updateFormStete(s);
            }
        }
        return BaseResult.getSuccessMessageEntity("数据获取成功", seeyonEntityList);
    }

    //    @Test
    public void testSaveNoProcess() {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("code", "03000119");
        jsonObject.put("name", "杭州陶瓷品市场亮晶晶酒店用品商行");
        JSONArray jsonArray = new JSONArray();
        JSONObject details1 = new JSONObject();
        details1.put("序号1", 1);
        details1.put("账户类型", "基本户");
        details1.put("开户行名称", "开户行名称");
        details1.put("银行账号", "123");

        JSONObject details2 = new JSONObject();
        details2.put("序号1", 2);
        details2.put("账户类型", "基本户");
        details2.put("开户行名称", "开户行名称");
        details2.put("银行账号", "123");
        jsonArray.add(details1);
        jsonArray.add(details2);
        jsonObject.put("details", jsonArray);
        //System.out.println(jsonObject.toJSONString());
        String dataXml = createTempData(jsonObject,CREATEARCHIVES);
        String loginName = "seeyon";
        Map res = new HashMap();
        res.put("loginName", loginName);
        res.put("dataXml", dataXml);
        JsonResultEntity result = saveNoProcess("formmain_0360", UPDATEARCHIVES,loginName, dataXml);
        logger.info("发起无流程表单结果：" + result);
    }

    private String createTempData(JSONObject jsonObject, String type) {
        String detailsStr = jsonObject.getString("details");
        StringBuffer stringBuffer = null;
        if (!StringUtils.isEmpty(detailsStr)) {
            List<JSONObject> attributeArray = JSON.parseArray(detailsStr, JSONObject.class);
            if (null != attributeArray && attributeArray.size() > 0) {
                stringBuffer = new StringBuffer();
                for (JSONObject object : attributeArray) {
                    //如果是更新类型的，增加title标签
                    if (type.equalsIgnoreCase(UPDATEARCHIVES)) {
                        stringBuffer.append(" <row>");

                        //stringBuffer.append(" <column  name=\"序号1\"><value><![CDATA["+object.getInteger("序号1")+"]]></value></column> ");
                        stringBuffer.append(" <column  name=\"是否默认\"><value><![CDATA["+StringUtil.nullConvert(object.getString("isdefault"))+"]]></value><title><![CDATA["+UUIDLong.absLongUUID()+"]]></title></column> ");
                        stringBuffer.append(" <column  name=\"开户行名称\"><value><![CDATA["+StringUtil.nullConvert(object.getString("splitbank"))+"]]></value><title><![CDATA["+UUIDLong.absLongUUID()+"]]></title></column> ");
                        stringBuffer.append(" <column  name=\"银行账号\"><value><![CDATA["+StringUtil.nullConvert(object.getString("combinno"))+"]]></value><title><![CDATA["+UUIDLong.absLongUUID()+"]]></title></column> ");
                        stringBuffer.append(" <column  name=\"联行号\"><value><![CDATA["+ StringUtil.nullConvert(object.getString("bankaccno"))+"]]></value><title><![CDATA["+UUIDLong.absLongUUID()+"]]></title></column> ");
                        stringBuffer.append(" </row>");

                    } else {

                        stringBuffer.append(" <row>");
                        //stringBuffer.append(" <column  name=\"序号1\"><value><![CDATA["+object.getInteger("序号1")+"]]></value></column> ");
                        stringBuffer.append("<column  name=\"是否默认\"><value><![CDATA["+StringUtil.nullConvert(object.getString("isdefault"))+"]]></value>" + 1 + "</column> ");
                        stringBuffer.append("<column  name=\"开户行名称\"><value><![CDATA["+StringUtil.nullConvert(object.getString("splitbank"))+"]]></value></column>");
                        stringBuffer.append("<column  name=\"银行账号\"><value><![CDATA["+StringUtil.nullConvert(object.getString("combinno"))+"]]></value></column> ");
                        stringBuffer.append("<column  name=\"联行号\"><value><![CDATA["+StringUtil.nullConvert(object.getString("bankaccno"))+"]]></value></column> ");
                        stringBuffer.append("</row>");
                    }

                }
            }

        }

        String str = "<forms  version=\"2.1\">\n" +
                "    <formExport>\n" +
                "        <summary  id=\"7382733425750590212\" name=\"formmain_0360\"/>\n" +
                "        <definitions>\n" +
                "            <column  id=\"field0001\" type=\"0\" name=\"供应商编码\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0002\" type=\"0\" name=\"供应商名称\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0007\" type=\"0\" name=\"税号\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0008\" type=\"0\" name=\"地址\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0009\" type=\"0\" name=\"电话\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0011\" type=\"0\" name=\"联系人\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0012\" type=\"0\" name=\"BIPID\" isNullable=\"false\" length=\"100\"/>\n" +
                "        </definitions>\n" +
                "        <values>\n" +
                "            <column  name=\"供应商编码\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("code"))+"]]></value></column>" +
                "            <column  name=\"供应商名称\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("name"))+"]]></value></column>" +
                "            <column  name=\"税号\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("taxpayerid"))+"]]></value></column>" +
                "            <column  name=\"地址\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("def1"))+"]]></value></column>" +
                "            <column  name=\"电话\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("def2"))+"]]></value></column>" +
                "            <column  name=\"联系人\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("def3"))+"]]></value></column>" +
                "            <column  name=\"BIPID\"><value><![CDATA["+StringUtil.nullConvert(jsonObject.getString("tripartiteId"))+"]]></value></column>" +
                "        </values>\n" +
                "        <subForms>\n" +
                "            <subForm>\n" +
                "                <definitions>\n" +
                "                    <column  id=\"field0003\" type=\"4\" name=\"序号1\" isNullable=\"false\" length=\"20\"/>\n" +
                "                    <column  id=\"field0004\" type=\"0\" name=\"是否默认\" isNullable=\"false\" length=\"100\"/>\n" +
                "                    <column  id=\"field0005\" type=\"0\" name=\"开户行名称\" isNullable=\"false\" length=\"100\"/>\n" +
                "                    <column  id=\"field0006\" type=\"0\" name=\"银行账号\" isNullable=\"false\" length=\"100\"/>\n" +
                "                    <column  id=\"field0013\" type=\"0\" name=\"联行号\" isNullable=\"false\" length=\"100\"/>\n" +
                "                </definitions>\n" +
                "                <values>\n";
        if (stringBuffer != null) {
            str += stringBuffer.toString();
            str += "                </values>\n" +
                    "            </subForm>\n" +
                    "        </subForms>\n" +
                    "    </formExport>\n" +
                    "</forms>";
        } else {
            str += "                </values>\n" +
                    "            </subForm>\n" +
                    "        </subForms>\n" +
                    "    </formExport>\n" +
                    "</forms>";
        }


        return str;
    }


    /**
     * 组织模板
     * @param jsonObject
     * @param type
     * @return
     */
    private String createOrgTempData(JSONObject jsonObject, String type) {
        String detailsStr = jsonObject.getString("details");
        StringBuffer stringBuffer = null;
        if (!StringUtils.isEmpty(detailsStr)) {
            List<JSONObject> attributeArray = JSON.parseArray(detailsStr, JSONObject.class);
            if (null != attributeArray && attributeArray.size() > 0) {
                stringBuffer = new StringBuffer();
                for (JSONObject object : attributeArray) {
                    //如果是更新类型的，增加title标签
                    if (type.equalsIgnoreCase(UPDATEARCHIVES)) {
                        stringBuffer.append(" <row>");
                        stringBuffer.append(" <column  name=\"账号\"><value><![CDATA["+StringUtil.nullConvert(object.getString("accnum"))+"]]></value><title><![CDATA[" + UUIDLong.absLongUUID() + "]]></title></column> ");
                        //stringBuffer.append(" <column  name=\"是否默认\"><value><![CDATA[" + object.getString("isdefault") + "]]></value><title><![CDATA[" + UUIDLong.absLongUUID() + "]]></title></column> ");
                        stringBuffer.append(" <column  name=\"开户行名称\"><value><![CDATA[" +StringUtil.nullConvert( object.getString("bankName")) + "]]></value><title><![CDATA[" + UUIDLong.absLongUUID() + "]]></title></column> ");
                        stringBuffer.append(" <column  name=\"开户行编码\"><value><![CDATA[" + StringUtil.nullConvert(object.getString("bankCode")) + "]]></value><title><![CDATA[" + UUIDLong.absLongUUID() + "]]></title></column> ");
                        stringBuffer.append(" <column  name=\"联行号\"><value><![CDATA[" + StringUtil.nullConvert(object.getString("cnapsCode")) + "]]></value><title><![CDATA[" + UUIDLong.absLongUUID() + "]]></title></column> ");
                        stringBuffer.append(" </row>");

                    } else {
                        stringBuffer.append(" <row>");
                        stringBuffer.append(" <column  name=\"账号\"><value><![CDATA["+StringUtil.nullConvert(object.getString("accnum"))+"]]></value></column> ");
                        // stringBuffer.append(" <column  name=\"是否默认\"><value><![CDATA[" + object.getString("isdefault") + "]]></value>" + 1 + "</column> ");
                        stringBuffer.append(" <column  name=\"开户行名称\"><value><![CDATA[" + StringUtil.nullConvert(object.getString("bankName")) + "]]></value></column>");
                        stringBuffer.append(" <column  name=\"开户行编码\"><value><![CDATA[" + StringUtil.nullConvert(object.getString("bankCode")) + "]]></value></column> ");
                        stringBuffer.append(" <column  name=\"联行号\"><value><![CDATA[" + StringUtil.nullConvert(object.getString("cnapsCode")) + "]]></value></column> ");
                        stringBuffer.append(" </row>");
                    }

                }
            }

        }

        String str = "<forms  version=\"2.1\">\n" +
                "    <formExport>\n" +
                "        <summary  id=\"7382733425750590212\" name=\"formmain_0380\"/>\n" +
                "        <definitions>\n" +
                "            <column  id=\"field0001\" type=\"0\" name=\"开户单位\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0008\" type=\"0\" name=\"BIPID\" isNullable=\"false\" length=\"100\"/>\n" +
                "            <column  id=\"field0009\" type=\"0\" name=\"单位编码\" isNullable=\"false\" length=\"100\"/>\n" +
                "        </definitions>\n" +
                "        <values>\n" +
                "            <column  name=\"开户单位\"><value><![CDATA[" + StringUtil.nullConvert(jsonObject.getString("name")) + "]]></value></column>" +
                "            <column  name=\"BIPID\"><value><![CDATA[" + StringUtil.nullConvert(jsonObject.getString("tripartiteId")) + "]]></value></column>" +
                "            <column  name=\"单位编码\"><value><![CDATA[" + StringUtil.nullConvert(jsonObject.getString("code")) + "]]></value></column>" +
                "        </values>\n" +
                "        <subForms>\n" +
                "            <subForm>\n" +
                "                <definitions>\n" +
                "                    <column  id=\"field0004\" type=\"0\" name=\"账号\" isNullable=\"false\" length=\"100\"/>\n" +
                "                    <column  id=\"field0003\" type=\"0\" name=\"开户行名称\" isNullable=\"false\" length=\"100\"/>\n" +
                "                    <column  id=\"field0007\" type=\"0\" name=\"开户行编码\" isNullable=\"false\" length=\"100\"/>\n" +
                "                    <column  id=\"field0010\" type=\"0\" name=\"联行号\" isNullable=\"false\" length=\"100\"/>\n" +
                "                </definitions>\n" +
                "                <values>\n";
        if (stringBuffer != null) {
            str += stringBuffer.toString();
            str += "                </values>\n" +
                    "            </subForm>\n" +
                    "        </subForms>\n" +
                    "    </formExport>\n" +
                    "</forms>";
        } else {
            str += "                </values>\n" +
                    "            </subForm>\n" +
                    "        </subForms>\n" +
                    "    </formExport>\n" +
                    "</forms>";
        }
        return str;
    }

    //交行CFS日志
    private String createCfsTempData(JSONObject jsonObject, String type){
        String xml = "<forms  version=\"2.1\"><formExport><summary  id=\"-8308614817594585886\" name=\"formmain_0527\"/><definitions><column  id=\"field0004\" type=\"0\" name=\"表单名称\" isNullable=\"false\" length=\"100\"/><column  id=\"field0005\" type=\"0\" name=\"数据库表名\" isNullable=\"false\" length=\"100\"/><column  id=\"field0006\" type=\"0\" name=\"表单ID\" isNullable=\"false\" length=\"100\"/><column  id=\"field0007\" type=\"0\" name=\"表单编号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0008\" type=\"0\" name=\"流程标题\" isNullable=\"false\" length=\"100\"/><column  id=\"field0009\" type=\"0\" name=\"事件类型\" isNullable=\"false\" length=\"100\"/><column  id=\"field0010\" type=\"0\" name=\"formApp\" isNullable=\"false\" length=\"100\"/><column  id=\"field0011\" type=\"0\" name=\"推送结果\" isNullable=\"false\" length=\"100\"/><column  id=\"field0012\" type=\"0\" name=\"流水号\" isNullable=\"false\" length=\"100\"/><column  id=\"field0013\" type=\"0\" name=\"返回信息\" isNullable=\"false\" length=\"100\"/></definitions><values><column  name=\"表单名称\"><value><![CDATA[{}]]></value></column><column  name=\"数据库表名\"><value><![CDATA[{}]]></value></column><column  name=\"表单ID\"><value><![CDATA[{}]]></value></column><column  name=\"表单编号\"><value><![CDATA[{}]]></value></column><column  name=\"流程标题\"><value><![CDATA[{}]]></value></column><column  name=\"事件类型\"><value><![CDATA[{}]]></value></column><column  name=\"formApp\"><value><![CDATA[{}]]></value></column><column  name=\"推送结果\"><value><![CDATA[{}]]></value></column><column  name=\"流水号\"><value><![CDATA[{}]]></value></column><column  name=\"返回信息\"><value><![CDATA[{}]]></value></column></values><subForms/></formExport></forms>";
        String tabNameCh = StringUtil.nullConvert(jsonObject.getString("tab_name_ch"));
        String tabNameEn = StringUtil.nullConvert(jsonObject.getString("tab_name_en"));
        String id = StringUtil.nullConvert(jsonObject.getString("id"));
        String billCode = StringUtil.nullConvert(jsonObject.getString("bill_code"));
        String title = StringUtil.nullConvert(jsonObject.getString("title"));
        String eventType = StringUtil.nullConvert(jsonObject.getString("event_type"));
        String formApp = StringUtil.nullConvert(jsonObject.getString("form_app_id"));
        String statusMsg = StringUtil.nullConvert(jsonObject.getString("status_msg"));
        String serialNo = StringUtil.nullConvert(jsonObject.getString("serial_no"));
        String result = StringUtil.nullConvert(jsonObject.getString("result"));
        String dataXml = StrUtil.format(xml,tabNameCh,tabNameEn,id,billCode,title,eventType,formApp,statusMsg,serialNo,result);
        return dataXml;
    }
    /***
     *
     * @content:推送无流程表单同步钉钉
     * @author 👻👻👻👻👻👻👻👻 yuqh
     * @date  2023年9月2日12:56:18
     * @param
     * @return void
     **/
    @Override
    public JsonResultEntity sendConDocTodd(JSONObject requestJson) {
        //todo 临时直接传递参数
        return BaseResult.getSuccessMessageEntity("传递钉钉成功→普通表单",iddInterfaceService.senddd(requestJson));
    }
    /***
     *
     * @content:流程表单传递钉钉
     * @author 👻👻👻👻👻👻👻👻 yuqh
     * @date  2023年9月5日09:38:38
     * @param
     * @return void
     **/
    @Override
    public JsonResultEntity sendProcessDocument(JSONObject requestJson) {
        return BaseResult.getSuccessMessageEntity("传递钉钉成功→流程表单",iddInterfaceService.senddd(requestJson));
    }

    /**
     *
     * @content 杭泰OA付款单传递CFS
     * @Param
     * @Return
     * @Author hecan
     * @Date 2023/10/12 15:57
     * **/
    @Override
    public String sendpayMentToCFS(Map<String, Object> businessData) {
        try {
            JSONObject jsonObject=new JSONObject();
            Object mainObj = businessData.get("formmain_0327");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0146"));//OA业务主键
            //付款摘要
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson_0329obj = businessData.get("formson_0329");
            JSONArray formson0329List = JSON.parseArray(JSON.toJSONString(formson_0329obj));
            boolean flag = false;
            if (formson0329List != null && formson0329List.size() > 0) {
                JSONArray formson0329Array = new JSONArray();
                for (Object o : formson0329List) {
                    JSONObject formson_0330Json = JSON.parseObject(JSON.toJSONString(o));
                    //判断开户银行是否是交通银行
                    if(null !=formson_0330Json.getString("field0211") && (formson_0330Json.getString("field0211").contains("交通银行") || formson_0330Json.getString("field0211").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails = new JSONObject();
                    jsonObjectDetails.put("payerAccName", businessDatamain.getString("field0116"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo", formson_0330Json.getString("field0137"));//转出方账号
                    jsonObjectDetails.put("curCode", "CNY");//付款方币种
                    jsonObjectDetails.put("payeeAccName", formson_0330Json.getString("field0136"));//收款人帐户名称
                    purposeBuff.append(formson_0330Json.getString("field0136"));
                    jsonObjectDetails.put("payeeAccNo", formson_0330Json.getString("field0210"));//收款人帐户号
                    jsonObjectDetails.put("amount", formson_0330Json.getString("field0135"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode", formson_0330Json.getString("field0257"));//收款人联行号
                    jsonObjectDetails.put("payType", "34");//结算方式
                    jsonObjectDetails.put("businessType", "04");//业务类别
                    jsonObjectDetails.put("isForindividual", "0");//是否对私付款
                    jsonObjectDetails.put("creditByCustomer", businessDatamain.getString("field0149"));//贷方客商辅助核算编码
                    jsonObjectDetails.put("debitByBankAcc", formson_0330Json.getString("field0137"));//借方银行账户辅助核算编码
                    String isQuick = null;
                    if (null !=formson_0330Json.getBigDecimal("field0135") && formson_0330Json.getBigDecimal("field0135").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick", isQuick);//加急标志
                    formson0329Array.add(jsonObjectDetails);
                    map.put("details", formson0329Array);
                }
            }
            purposeBuff.append("对公付款单款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0146"));
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr", map);
                logger.info("对公付款单传递CFS在SeeYonInterFaceImpl中的请求参数为:"+JSONObject.toJSONString(jsonObject));
                 String result = payMentService.sendOAPayMentToCFS(jsonObject,"pay");
                //String result="{\"statusMsg\":\"当前为对公交易，收款方联行号不能为空！\",\"erpVoucherNoCfs\":\"DG202402280158\",\"serialNo\":\"\"}";
                logger.info("对公付款单传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新付款单推送标识----------");
                //更新付款单的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0327");
                seeyonEntity.setPushField("field0255");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("付款信息保存成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) && (null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------付款单推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------付款单推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            logger.info("杭泰OA付款单数据获取失败，原因为:"+e.getMessage());
        }
        return null;
    }

    /**
     *
     * @content 杭泰OA报销单传递CFS
     * @Param
     * @Return
     * @Author hecan
     * @Date 2023/10/16 15:27
     * **/
    @Override
    public String sendBusinessExpenseToCFS(Map<String, Object> businessData,String formApp) {
        try {
            String result=null;
            switch (formApp){
                case "-321958445006631163"://差旅报销单
                    result= travelReimbursement(businessData,formApp);
                    break;
                case "-4485599744122928342"://招待报销单
                    result= hospitalityReimbursement(businessData,formApp);
                    break;
                case "4728403652378707515"://日常报销单
                    result=routineReimbursement(businessData,formApp);
                    break;
                default:
                    break;
            }
            return result;
        }catch (Exception e){
            e.printStackTrace();
            logger.info("杭泰报销单失败：{}"+e.getMessage());
        }
        return null;
    }

    //差旅报销单
    private String travelReimbursement(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object  mainObj = businessData.get("formmain_0307");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0094"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson0311Obj = businessData.get("formson_0311");
            JSONArray formson_0311List = JSON.parseArray(JSON.toJSONString(formson0311Obj));
            boolean flag=false;
            if(formson_0311List!=null && formson_0311List.size()>0){
                JSONArray formson_0311Array = new JSONArray();
                for (Object o : formson_0311List) {
                    JSONObject formson_0311Json = JSON.parseObject(JSON.toJSONString(o));
                    if(null !=formson_0311Json.getString("field0265") && (formson_0311Json.getString("field0265").contains("交通银行") || formson_0311Json.getString("field0265").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails=new JSONObject();
                    //根据收款方id查询收款方名称
                    SeeyonEntity seeyonEntity = new SeeyonEntity();
                    seeyonEntity.setId(businessDatamain.getString("field0015"));
                    List<SeeyonEntity> seeyonEntities = seeYonDao.selectOAListByField0258(seeyonEntity);
                    if (seeyonEntities.size() > 0) {
                        jsonObjectDetails.put("payeeAccName", seeyonEntities.get(0).getName());//收款人帐户名称
                    } else {
                        jsonObjectDetails.put("payeeAccName", businessDatamain.getString("field0015"));//收款人帐户名称
                    }
                    jsonObjectDetails.put("payerAccName",businessDatamain.getString("field0188"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo",formson_0311Json.getString("field0266"));//转出方账号
                    jsonObjectDetails.put("curCode","CNY");//付款方币种
                    //jsonObjectDetails.put("payeeAccName",formson_0311Json.getString("field0313"));//收款人帐户名称
                    purposeBuff.append(jsonObjectDetails.getString("payeeAccName"));
                    jsonObjectDetails.put("payeeAccNo",formson_0311Json.getString("field0218"));//收款人帐户号
                    jsonObjectDetails.put("amount",formson_0311Json.getString("field0215"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode",formson_0311Json.getString("field0311"));//收款人联行号
                    jsonObjectDetails.put("payType","34");//结算方式
                    String isQuick=null;
                    if (null !=formson_0311Json.getBigDecimal("field0215") && formson_0311Json.getBigDecimal("field0215").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick",isQuick);//加急标志
                    formson_0311Array.add(jsonObjectDetails);
                    map.put("details",formson_0311Array);
                }
            }
            purposeBuff.append("差旅报销款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0094"));
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr",map);
                String result= payMentService.sendExpenseToCFS(jsonObject);
                //String result="{\"statusMsg\":\"成功\",\"erpVoucherNoCfs\":\"-9050113785393100178\",\"serialNo\":\"1111\"}";
                logger.info("差旅报销单传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新差旅报销单推送标识----------");
                //更新付款单的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0307");
                seeyonEntity.setPushField("field0309");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("报销交易信息验证成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) && (null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------差旅报销单推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------差旅报销单推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            e.printStackTrace();
            logger.info("差旅报销单开始从SeeYonInterFaceImpl传递CFS失败，原因为:{}",e.getMessage());
        }
        return null;
    }

    //招待报销单
    private String hospitalityReimbursement(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object  mainObj = businessData.get("formmain_0294");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0053"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson_0297Obj = businessData.get("formson_0297");
            JSONArray formson_0297List = JSON.parseArray(JSON.toJSONString(formson_0297Obj));
            boolean flag=false;
            if(formson_0297List!=null && formson_0297List.size()>0){
                JSONArray formson0297Array = new JSONArray();
                for (Object o : formson_0297List) {
                    JSONObject formson_0297Json = JSON.parseObject(JSON.toJSONString(o));
                    if(null != formson_0297Json.getString("field0098") && (formson_0297Json.getString("field0098").contains("交通银行") || formson_0297Json.getString("field0098").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails=new JSONObject();
                    //根据收款方id查询收款方名称
                    SeeyonEntity seeyonEntity = new SeeyonEntity();
                    seeyonEntity.setId(businessDatamain.getString("field0002"));
                    List<SeeyonEntity> seeyonEntities = seeYonDao.selectOAListByField0258(seeyonEntity);
                    if (seeyonEntities.size() > 0) {
                        jsonObjectDetails.put("payeeAccName", seeyonEntities.get(0).getName());//收款人帐户名称
                    } else {
                        jsonObjectDetails.put("payeeAccName", businessDatamain.getString("field0002"));//收款人帐户名称
                    }
                    jsonObjectDetails.put("payerAccName",businessDatamain.getString("field0080"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo",formson_0297Json.getString("field0073"));//转出方账号
                    jsonObjectDetails.put("curCode","CNY");//付款方币种
                    //jsonObjectDetails.put("payeeAccName",formson_0297Json.getString("field0178"));//收款人帐户名称
                    purposeBuff.append(jsonObjectDetails.getString("payeeAccName"));
                    jsonObjectDetails.put("payeeAccNo",formson_0297Json.getString("field0136"));//收款人帐户号
                    jsonObjectDetails.put("amount",formson_0297Json.getString("field0100"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode",formson_0297Json.getString("field0176"));//收款人联行号
                    jsonObjectDetails.put("payType","34");//结算方式
                    String isQuick=null;
                    if (null !=formson_0297Json.getBigDecimal("field0100") && formson_0297Json.getBigDecimal("field0100").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick",isQuick);//加急标志
                    formson0297Array.add(jsonObjectDetails);
                    map.put("details",formson0297Array);
                }
            }
            purposeBuff.append("招待报销款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0053"));
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr",map);
                String result= payMentService.sendExpenseToCFS(jsonObject);
                //String result="{\"statusMsg\":\"成功\",\"erpVoucherNoCfs\":\"-9050113785393100178\",\"serialNo\":\"1111\"}";
                logger.info("招待报销单传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新招待报销单推送标识----------");
                //更新付款单的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0294");
                seeyonEntity.setPushField("field0174");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("报销交易信息验证成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) && (null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------招待报销单推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------招待报销单推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            e.printStackTrace();
            logger.info("招待报销单开始从SeeYonInterFaceImpl传递CFS失败，原因为:{}",e.getMessage());
        }
        return null;
    }

    //日常报销单
    private String routineReimbursement(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object mainObj = businessData.get("formmain_0314");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0220"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson_0317Obj = businessData.get("formson_0317");
            JSONArray formson_0317List = JSON.parseArray(JSON.toJSONString(formson_0317Obj));
            boolean flag=false;
            if(formson_0317List!=null && formson_0317List.size()>0){
                JSONArray formson_0317Array = new JSONArray();
                for (Object o : formson_0317List) {
                    JSONObject formson_0317Json = JSON.parseObject(JSON.toJSONString(o));
                    if(null != formson_0317Json.getString("field0268") && (formson_0317Json.getString("field0268").contains("交通银行") || formson_0317Json.getString("field0268").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails=new JSONObject();
                    //根据收款方id查询收款方名称
                    SeeyonEntity seeyonEntity = new SeeyonEntity();
                    seeyonEntity.setId(businessDatamain.getString("field0015"));
                    List<SeeyonEntity> seeyonEntities = seeYonDao.selectOAListByField0258(seeyonEntity);
                    if (seeyonEntities.size() > 0) {
                        jsonObjectDetails.put("payeeAccName", seeyonEntities.get(0).getName());//收款人帐户名称
                    } else {
                        jsonObjectDetails.put("payeeAccName", businessDatamain.getString("field0015"));//收款人帐户名称
                    }
                    jsonObjectDetails.put("payerAccName",businessDatamain.getString("field0188"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo",formson_0317Json.getString("field0269"));//转出方账号
                    jsonObjectDetails.put("curCode","CNY");//付款方币种
                    //jsonObjectDetails.put("payeeAccName",formson_0317Json.getString("field0299"));//收款人帐户名称
                    purposeBuff.append(jsonObjectDetails.getString("payeeAccName"));
                    jsonObjectDetails.put("payeeAccNo",formson_0317Json.getString("field0217"));//收款人帐户号
                    jsonObjectDetails.put("amount",formson_0317Json.getString("field0215"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode",formson_0317Json.getString("field0297"));//收款人联行号
                    jsonObjectDetails.put("payType","34");//结算方式
                    String isQuick=null;
                    if (null !=formson_0317Json.getBigDecimal("field0215") && formson_0317Json.getBigDecimal("field0215").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick",isQuick);//加急标志
                    formson_0317Array.add(jsonObjectDetails);
                    map.put("details",formson_0317Array);
                }
            }
            purposeBuff.append("日常报销款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0220"));
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr",map);
                String result= payMentService.sendExpenseToCFS(jsonObject);
                logger.info("日常报销单传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新日常报销单推送标识----------");
                //更新付款单的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0314");
                seeyonEntity.setPushField("field0295");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("报销交易信息验证成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) &&(null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------日常报销单推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------日常报销单推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            e.printStackTrace();
            logger.info("日常报销单开始从SeeYonInterFaceImpl传递CFS失败，原因为:{}",e.getMessage());
        }
        return null;
    }

    /**
     *
     * @content 杭泰OA资金归集，资金拨付，同名账户划转，借款单传递CFS
     * @Param
     * @Return
     * @Author hecan
     * @Date 2023/12/20 9:12
     * **/
    @Override
    public String sendOtherFourReceipt(Map<String,Object> map, String formApp) {
        try {
            String result=null;
            switch (formApp){
                case "910366613209564645"://资金归集
                    result= fundCollection(map,formApp);
                    break;
                case "-102527561419044497"://资金拨付
                    result=fundAllocation(map,formApp);
                    break;
                case "-1193625514072190978"://同名账户划转
                    result=accountTransfer(map,formApp);
                    break;
                case "4645133897573090505"://借款单(借还款)
                    result= loanRepayment(map,formApp);
                    break;
                default:
                    break;
            }
            return result;
        }catch (Exception e){
            e.printStackTrace();
            logger.info("杭泰OA资金归集，资金拨付，同名账户划转，借款单传递CFS错误，原因为{}",e.getMessage());
        }
        return null;
    }

    @Override
    public JsonResultEntity thirdInterfaceSeeYonDefinitionRePush(JSONObject jsonObject) throws Exception {
        JSONObject requestData = jsonObject.getJSONObject("jsonStr");
        JSONArray resultEntityArray = new JSONArray();
        if(null == requestData){
            throw  new BaseSystemException("参数传递错误需要jsonStr!");
        }
        //表单模版ID
        String formAppId = requestData.getString("formAppId");
        //事件事件类型
        String eventType = requestData.getString("eventType");
        //数据源编码
        String dataSourceCode = requestData.getString("dataSourceCode");
        //主表ID集合 formMainIds
        JSONArray formMainIds = requestData.getJSONArray("formMainIds");
        if(StrUtil.isEmpty(eventType)){
            throw  new BaseSystemException("需要传递eventType 参照致远OA事件!");
        }
        if(StrUtil.isEmpty(formAppId)){
            throw  new BaseSystemException("需要传递formAppId 参照致远OA 表 CAP_FORM_DEFINITION!");
        }
        if(StrUtil.isEmpty(dataSourceCode)){
            throw  new BaseSystemException("需要传递dataSourceCode 参照中台表 sys_data_source!");
        }
        if(null == formMainIds || formMainIds.size() == 0){
            throw  new BaseSystemException("需要传递业务主表数据id集合,不允许全量推送!");
        }

        SeeYonInterFaceEntity seeYonInterFaceEntity = new SeeYonInterFaceEntity();
        BeanUtil.copyProperties(requestData,seeYonInterFaceEntity);
        List<SeeYonInterFaceEntity> seeYonInterFaceEntityList = seeYonInterFaceDao.queryDefinitionInfo(seeYonInterFaceEntity);
        System.out.println(seeYonInterFaceEntityList);
        if(null != seeYonInterFaceEntityList && seeYonInterFaceEntityList.size() >0){
            for(SeeYonInterFaceEntity interFaceEntity : seeYonInterFaceEntityList){
                String field_info = interFaceEntity.getField_info();
                JSONObject infoJson = JSON.parseObject(field_info);
                //获取主表信息
                JSONObject formMain = infoJson.getJSONObject("front_formmain");
                //获取明细表信息
                JSONArray formSons = infoJson.getJSONArray("formsons");
                //主表tableName
                String formMainTableName = formMain.getString("tableName");

                /** 设置主表查询条件*/
                interFaceEntity.setTabName(formMainTableName);
                interFaceEntity.setDataSourceCode(dataSourceCode);
                interFaceEntity.setFormMainIds( formMainIds.toJavaList(String.class) );

                List<Map<String, Object>> forMainList = seeYonInterFaceDao.queryDefinitionData(interFaceEntity);
                for (Map<String, Object> forMainRow : forMainList) {
                    //定义致远OA事件对象
                    JSONObject seeYonBean = new JSONObject();
                    //定义主表对象
                    JSONObject formMainObj = new JSONObject();
                    //获取主表ID
                    String forMainId = String.valueOf(forMainRow.get("ID"));
                    //组装主表数据
                    for (Map.Entry<String, Object> entry : forMainRow.entrySet()) {
                        formMainObj.put(entry.getKey().toLowerCase(),entry.getValue());
                     }
                    //组装明细表数据
                    if(null != formSons && formSons.size() > 0){
                        for(Object formSon : formSons){
                            JSONObject son = JSON.parseObject(JSON.toJSONString(formSon));
                            //明细数据
                            String sonTableName = son.getString("tableName");
                            SeeYonInterFaceEntity details = new SeeYonInterFaceEntity();
                            details.setFormMainId(forMainId);
                            details.setTabName(sonTableName);
                            details.setDataSourceCode(dataSourceCode);
                            JSONArray jsonArray = new JSONArray();
                            List<Map<String, Object>> forSonList = seeYonInterFaceDao.queryDefinitionData(details);
                            for (Map<String, Object> forSons : forSonList) {
                                //组装明细数据
                                JSONObject forSonJson = new JSONObject();
                                for (Map.Entry<String, Object> entry : forSons.entrySet()) {
                                    forSonJson.put(entry.getKey().toLowerCase(),entry.getValue());
                                 }
                                jsonArray.add(forSonJson);
                            }
                            //设置明细表数据
                            seeYonBean.put(sonTableName,jsonArray);
                        }
                    }

                    seeYonBean.put(formMainTableName,formMainObj);
                    JSONObject rePushRequestData = new JSONObject();
                    JSONObject object = new JSONObject();
                    object.put("formApp",formAppId);
                    object.put("eventType",eventType);
                    object.put("businessDataStr",seeYonBean.toJSONString());
                    object.put("affairId","");
                    object.put("summaryId","");
                    object.put("currentActivityId","");
                    object.put("id",forMainId);
                    logger.info("Method:thirdInterfaceSeeYonDefinitionRePush 组装seeYonBean DATA: {}",seeYonBean.toJSONString());

                    rePushRequestData.put("jsonStr",object);


                    JsonResultEntity  resultEntity = thirdInterfaceSeeYonPlugInInterfaceEntrance(rePushRequestData);
                    if(null != resultEntity){
                        resultEntityArray.add(resultEntity.getAttribute());
                    }else{
                        JSONObject jsonResultEntity  = new JSONObject();
                        jsonResultEntity.put("msg","从新推送失败");
                        jsonResultEntity.put("id",forMainId);
                        resultEntityArray.add(jsonResultEntity);

                    }

                }
            }
        }
        return BaseResult.getSuccessMessageEntity("从新推送执行结束",resultEntityArray);
    }

    //资金归集
    private String fundCollection(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object mainObj = businessData.get("formmain_0362");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0047"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            purposeBuff.append(businessDatamain.getString("field0001"));
            Object formson_0378obj = businessData.get("formson_0378");
            JSONArray formson_0378List = JSON.parseArray(JSON.toJSONString(formson_0378obj));
            boolean flag = false;
            if (formson_0378List != null && formson_0378List.size() > 0) {
                JSONArray formson_0378Array = new JSONArray();
                for (Object o : formson_0378List) {
                    JSONObject formson_0330Json = JSON.parseObject(JSON.toJSONString(o));
                    //判断开户银行是否是交通银行
                    if(null !=formson_0330Json.getString("field0007") && (formson_0330Json.getString("field0007").contains("交通银行") || formson_0330Json.getString("field0007").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails = new JSONObject();
                    jsonObjectDetails.put("payerAccName", formson_0330Json.getString("field0003"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo", formson_0330Json.getString("field0008"));//转出方账号
                    jsonObjectDetails.put("curCode", "CNY");//付款方币种
                    jsonObjectDetails.put("payeeAccName", businessDatamain.getString("field0001"));//收款人帐户名称
                    jsonObjectDetails.put("payeeAccNo", businessDatamain.getString("field0023"));//收款人帐户号
                    jsonObjectDetails.put("amount", formson_0330Json.getString("field0004"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode", businessDatamain.getString("field0046"));//收款人联行号
                    jsonObjectDetails.put("payType", "34");//结算方式
                    jsonObjectDetails.put("businessType", "04");//业务类别
                    jsonObjectDetails.put("isForindividual", "0");//是否对私付款
                    jsonObjectDetails.put("debitByCustomer", businessDatamain.getString("field0037"));//借方客商辅助核算编码
                    jsonObjectDetails.put("creditByCustomer", formson_0330Json.getString("field0036"));//贷方客商辅助核算编码
                    jsonObjectDetails.put("creditByBankAcc", formson_0330Json.getString("field0008"));//贷方银行账户辅助核算编码
                    String isQuick = null;
                    if (null !=formson_0330Json.getBigDecimal("field0004") && (formson_0330Json.getBigDecimal("field0004").compareTo(BigDecimal.valueOf(50000)) == 1)) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick", isQuick);//加急标志
                    formson_0378Array.add(jsonObjectDetails);
                    map.put("details", formson_0378Array);
                }
            }
            purposeBuff.append("资金归集款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0047"));//单据编号
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr", map);
                String result = payMentService.sendOAPayMentToCFS(jsonObject,"fundc");
                logger.info("资金归集传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新资金归集推送标识----------");
                //更新资金归集的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0362");
                seeyonEntity.setPushField("field0045");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("付款信息保存成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) && (null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                     seeYonDao.updatepush(seeyonEntity);
                    logger.info("------资金归集推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                     seeYonDao.updatepush(seeyonEntity);
                    logger.info("------资金归集推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            logger.info("杭泰OA资金归集数据获取失败，原因为:"+e.getMessage());
        }
        return null;
    }

    //资金拨付
    private String fundAllocation(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object mainObj = businessData.get("formmain_0464");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0045"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson_0465obj = businessData.get("formson_0465");
            JSONArray formson_0465List = JSON.parseArray(JSON.toJSONString(formson_0465obj));
            boolean flag = false;
            if (formson_0465List != null && formson_0465List.size() > 0) {
                JSONArray formson_0465Array = new JSONArray();
                for (Object o : formson_0465List) {
                    JSONObject formson_0330Json = JSON.parseObject(JSON.toJSONString(o));
                    //判断开户银行是否是交通银行
                    if(null != businessDatamain.getString("field0022") && (businessDatamain.getString("field0022").contains("交通银行") || businessDatamain.getString("field0022").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails = new JSONObject();
                    jsonObjectDetails.put("payerAccName", businessDatamain.getString("field0001"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo", businessDatamain.getString("field0023"));//转出方账号
                    jsonObjectDetails.put("curCode", "CNY");//付款方币种
                    jsonObjectDetails.put("payeeAccName", formson_0330Json.getString("field0003"));//收款人帐户名称
                    purposeBuff.append(formson_0330Json.getString("field0003"));
                    jsonObjectDetails.put("payeeAccNo", formson_0330Json.getString("field0008"));//收款人帐户号
                    jsonObjectDetails.put("amount", formson_0330Json.getString("field0004"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode", formson_0330Json.getString("field0044"));//收款人联行号
                    jsonObjectDetails.put("payType", "34");//结算方式
                    jsonObjectDetails.put("businessType", "04");//业务类别
                    jsonObjectDetails.put("isForindividual", "0");//是否对私付款
                    jsonObjectDetails.put("debitByCustomer", formson_0330Json.getString("field0036"));//借方客商辅助核算编码
                    jsonObjectDetails.put("creditByCustomer", businessDatamain.getString("field0037"));//贷方客商辅助核算编码
                    jsonObjectDetails.put("creditByBankAcc", formson_0330Json.getString("field0023"));//贷方银行账户辅助核算编码

                    String isQuick = null;
                    if (null !=formson_0330Json.getBigDecimal("field0004") && formson_0330Json.getBigDecimal("field0004").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick", isQuick);//加急标志
                    formson_0465Array.add(jsonObjectDetails);
                    map.put("details", formson_0465Array);
                }
            }
            purposeBuff.append("资金拨付款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0045"));//单据编号
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr", map);
                String result = payMentService.sendOAPayMentToCFS(jsonObject,"funda");
                logger.info("资金拨付传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新资金拨付推送标识----------");
                //更新资金拨付的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0464");
                seeyonEntity.setPushField("field0043");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("付款信息保存成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) &&(null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------资金拨付推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------资金拨付推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            logger.info("杭泰OA资金拨付数据获取失败，原因为:"+e.getMessage());
        }
        return null;
    }

    //同名账户划转
    private String accountTransfer(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object mainObj = businessData.get("formmain_0467");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0045"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson_0469obj = businessData.get("formson_0469");
            JSONArray formson_0469List = JSON.parseArray(JSON.toJSONString(formson_0469obj));
            boolean flag = false;
            if (formson_0469List != null && formson_0469List.size() > 0) {
                JSONArray formson_0469Array = new JSONArray();
                for (Object o : formson_0469List) {
                    JSONObject formson_0469Json = JSON.parseObject(JSON.toJSONString(o));
                    //判断开户银行是否是交通银行
                    if(null!= formson_0469Json.getString("field0015") && (formson_0469Json.getString("field0015").contains("交通银行") || formson_0469Json.getString("field0015").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails = new JSONObject();
                    jsonObjectDetails.put("payerAccName", businessDatamain.getString("field0021"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo", formson_0469Json.getString("field0016"));//转出方账号
                    jsonObjectDetails.put("curCode", "CNY");//付款方币种
                    jsonObjectDetails.put("payeeAccName", businessDatamain.getString("field0021"));//收款人帐户名称
                    jsonObjectDetails.put("payeeAccNo", formson_0469Json.getString("field0019"));//收款人帐户号
                    purposeBuff.append(formson_0469Json.getString("field0019"));
                    jsonObjectDetails.put("amount", formson_0469Json.getString("field0020"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode", formson_0469Json.getString("field0044"));//收款人联行号
                    jsonObjectDetails.put("payType", "34");//结算方式
                    jsonObjectDetails.put("businessType", "04");//业务类别
                    jsonObjectDetails.put("isForindividual", "0");//是否对私付款
                    jsonObjectDetails.put("debitByBankAcc", formson_0469Json.getString("field0019"));//借方银行账户辅助核算编码
                    jsonObjectDetails.put("creditByCustomer", businessDatamain.getString("field0038"));//贷方客商辅助核算编码
                    jsonObjectDetails.put("creditByBankAcc", formson_0469Json.getString("field0016"));//贷方银行账户辅助核算编码
                    String isQuick = null;
                    if (null !=formson_0469Json.getBigDecimal("field0020") && formson_0469Json.getBigDecimal("field0020").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick", isQuick);//加急标志
                    formson_0469Array.add(jsonObjectDetails);
                    map.put("details", formson_0469Array);
                }
            }
            purposeBuff.append("同名账户划转款项,单据号-");
            purposeBuff.append(businessDatamain.getString("field0045"));//单据编号
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr", map);
                String result = payMentService.sendOAPayMentToCFS(jsonObject,"acc");
                logger.info("同名账户划转传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新同名账户划转推送标识----------");
                //更新资金拨付的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0467");
                seeyonEntity.setPushField("field0043");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("付款信息保存成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) && (null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------同名账户划转推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------同名账户划转推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            logger.info("杭泰OA同名账户划转数据获取失败，原因为:"+e.getMessage());
        }
        return null;
    }

    //借还款
    private String loanRepayment(Map<String, Object> businessData, String formApp){
        try {
            JSONObject jsonObject=new JSONObject();
            Object mainObj = businessData.get("formmain_0293");
            JSONObject businessDatamain = JSON.parseObject(JSON.toJSONString(mainObj));
            JSONObject map=new JSONObject();
            map.put("erpVoucherNo",businessDatamain.getString("field0056"));//OA业务主键
            StringBuffer purposeBuff = new StringBuffer("付");
            Object formson_0399obj = businessData.get("formson_0399");
            JSONArray formson_0399List = JSON.parseArray(JSON.toJSONString(formson_0399obj));
            boolean flag = false;
            if (formson_0399List != null && formson_0399List.size() > 0) {
                JSONArray formson_0399Array = new JSONArray();
                for (Object o : formson_0399List) {
                    JSONObject formson_0399Json = JSON.parseObject(JSON.toJSONString(o));
                    //判断开户银行是否是交通银行
                    if(null !=formson_0399Json.getString("field0078") && (formson_0399Json.getString("field0078").contains("交通银行") || formson_0399Json.getString("field0078").contains("上海银行"))){
                        flag=true;
                    }
                    JSONObject jsonObjectDetails = new JSONObject();
                    //根据转出方得id查询转出方名称
                    SeeyonEntity seeyonEntity = new SeeyonEntity();
                    seeyonEntity.setId(businessDatamain.getString("field0006"));
                    List<SeeyonEntity> seeyonEntities = seeYonDao.selectOAListByField0258(seeyonEntity);
                    if (seeyonEntities.size() > 0) {
                        jsonObjectDetails.put("payeeAccName", seeyonEntities.get(0).getName());//收款人帐户名称
                    }
                    jsonObjectDetails.put("payerAccName", businessDatamain.getString("field0074"));//转出方帐户名
                    jsonObjectDetails.put("payerAccNo", formson_0399Json.getString("field0079"));//转出方账号
                    jsonObjectDetails.put("curCode", "CNY");//付款方币种
                    //jsonObjectDetails.put("payeeAccName", businessDatamain.getString("field0006"));//收款人帐户名称
                    purposeBuff.append(jsonObjectDetails.getString("payeeAccName"));
                    jsonObjectDetails.put("payeeAccNo", formson_0399Json.getString("field0081"));//收款人帐户号
                    jsonObjectDetails.put("amount", formson_0399Json.getString("field0077"));//余额/发生额
                    jsonObjectDetails.put("payeeBankCode", formson_0399Json.getString("field0093"));//收款人联行号
                    jsonObjectDetails.put("payType", "34");//结算方式
                    jsonObjectDetails.put("businessType", "04");//业务类别
                    jsonObjectDetails.put("isForindividual", "0");//是否对私付款
                    jsonObjectDetails.put("creditByCustomer", businessDatamain.getString("field0084"));//贷方客商辅助核算编码
                    jsonObjectDetails.put("debitByPersonnel", businessDatamain.getString("field0094"));//借方人员辅助核算编码
                    jsonObjectDetails.put("creditByBankAcc", formson_0399Json.getString("field0079"));//贷方银行账户辅助核算编码
                    String isQuick = null;
                    if (null !=formson_0399Json.getBigDecimal("field0077") && formson_0399Json.getBigDecimal("field0077").compareTo(BigDecimal.valueOf(50000)) == 1) {//如果=1，说明大于50000，如果=-1，说明小于50000
                        isQuick = "1";//加急标志  1:加急  0：不加急
                    } else {
                        isQuick = "0";//普通标志
                    }
                    jsonObjectDetails.put("isQuick", isQuick);//加急标志
                    formson_0399Array.add(jsonObjectDetails);
                    map.put("details", formson_0399Array);
                }
            }
            purposeBuff.append("借款单款项,借款单据编号-");
            purposeBuff.append(businessDatamain.getString("field0056"));//单据编号
            map.put("purpose",purposeBuff.toString());//摘要
            //只有交通银行的才传递CFS
            if(flag==true){
                jsonObject.put("jsonStr", map);
                String result = payMentService.sendOAPayMentToCFS(jsonObject,"loan");
                logger.info("借还款传递CFS在SeeYonInterFaceImpl中的返回结果为:"+result);
                JSONObject jsonObjectResult = JSONObject.parseObject(result);
                logger.info("------开始更新借还款推送标识----------");
                //更新资金拨付的推送状态
                SeeyonEntity seeyonEntity=new SeeyonEntity();
                seeyonEntity.setTableName("formmain_0293");
                seeyonEntity.setPushField("field0092");
                seeyonEntity.setId(businessDatamain.getString("id"));
                if("付款信息保存成功".equalsIgnoreCase(jsonObjectResult.getString("statusMsg")) && (null!=jsonObjectResult.getString("serialNo") && !"".equals(jsonObjectResult.getString("serialNo")))){
                    seeyonEntity.setPushValue("推送成功");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------借还款推送标识更新为推送成功完成----------");
                }else{
                    seeyonEntity.setPushValue("推送失败");
                    seeYonDao.updatepush(seeyonEntity);
                    logger.info("------借还款推送标识更新为推送失败完成----------");
                }
                return result;
            } else {
                logger.info("付款方开户银行不是交通银行类型或者没有银行明细，传递不了CFS");
                return null;
            }
        }catch (Exception e){
            logger.info("杭泰OA借还款数据获取失败，原因为:"+e.getMessage());
        }
        return null;
    }




}
